/* 
 * A = fzeros(m,n)
 *
 * Allocate an m-by-n block of single-precision floating point numbers.
 */

#include <mex.h>

void mexFunction(int nlhs, mxArray** plhs,
                 int nrhs, const mxArray** prhs)
{
    int m = 1;
    int n = 1;

    /* Process arguments */

    if (nrhs > 2)
        mexErrMsgTxt("Wrong number of arguments");

    if (nrhs > 0) {
        if (!mxIsNumeric(prhs[0]) || mxGetM(prhs[0]) * mxGetN(prhs[0]) != 1)
            mexErrMsgTxt("m must be scalar");
        m = (int) *mxGetPr(prhs[0]);
	n = m;
    }

    if (nrhs > 1) {
        if (!mxIsNumeric(prhs[1]) || mxGetM(prhs[1]) * mxGetN(prhs[1]) != 1)
            mexErrMsgTxt("m must be scalar");
        n = (int) *mxGetPr(prhs[1]);
    }

    plhs[0] = mxCreateNumericMatrix(m, n, mxSINGLE_CLASS, mxREAL);
}
