% [adj, A] = matrixbrite(G)
%
% Compute two sparse adjacency matrix representations of G.
%  adj(i,j) = delay when there is an edge between i and j, 0 ow
%  A(i.j)   = index of the edge between i and j, 0 if none exists

function [adj, A] = matrixbrite(G)

adj = spalloc(G.nv, G.nv, G.ne);
A   = spalloc(G.nv, G.nv, G.ne);

for k = 1:G.ne
  i = G.e(k).from + 1;
  j = G.e(k).to   + 1;
  adj(i,j) = G.e(k).delay;
  A(i,j)   = k;
end

adj = adj + adj';
A   = A + A';
