function [data] = run_trial(end_hosts, sizes, adj, A, ne)

if nargin < 5
  ne = full(max(max(A)));
end

t0 = clock;

% Start with empty set and extend
V        = [];
Vinfo    = [];
R        = fzeros(3000);
prevsize = 0;

data = [];
fprintf('n:\tk\t%%\ttime\n');
for i = 1:length(sizes)

  [V, R, Vinfo, k, percent, tall] = ...
     scanadd(end_hosts(1:prevsize), ...
             end_hosts(prevsize+1:sizes(i)), ...
             V, R, Vinfo, adj, A, ne, 0);

  fprintf('%d:\t%d\t%2.2f\t%f\n', sizes(i), k, percent, tall);
  data = [data; sizes(i), k, percent, tall];
end

fprintf('   Run completed in %f seconds\n', etime(clock, t0));
