/**
 *OBJECT:	This class is used
 *				for the A* algorithm with a Fibonacci heap
 *				priority queue.
 *
 * @version    $Id: AStarFibNode.java,v 1.1 12/26/2001
 *
 * @author    Mark Rabin
 *
 * Revisions:
 *     $Log: AStarFibNode.java,v 1.1$
 *     Revision 1.1  12/26/2001
 *     Initial revision
 *
 */


// package LossyLink;


public class AStarFibNode extends FibNode {
	double goalEstVal;	//estimate of the distance from this node to the goal

	/**
	 * Constructor to initialize the node.
	 *
	 * @param id the identification number of the new node
	 * @parma value the current shortest path estimate
	 */
	public AStarFibNode( int id, double value ) {
        super( id, value );
   }

	/**
	 * Method to return the key value in for the node in the heap
	 *
	 * @return the shortest path estimate plus the estimate of
	 *			the distance to the goal
	 */
	public double keyValue() {
		return ( value + goalEstVal );
	}

}