function out = newXvector( GmatrixFileName, BvectorFileName, outputXvectorName )


% Open G matrix --------------------------------------------------

fid = fopen( GmatrixFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', GmatrixFileName );
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
%G = spalloc( nrows, ncols, nnz )

for i = 1 : nrows
    for j = 1 : ncols
        G( i, j ) = 0;
    end
end

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        G( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );

% fprintf('G nrows : %d\n', nrows );
% fprintf('G ncols : %d\n', ncols );

% Open B Vector ----------------------------------------------------

fidBvector = fopen( BvectorFileName, 'r' );
if fidBvector == -1
    fprintf('ERROR : Can not read file %s', BvectorFileName );
end

ncols = fscanf( fidBvector, '%d[\t\n\r\f ]' );
% fprintf( 'B vector ncols [%d]\n', ncols );
for i = 1 : ncols
    element = fscanf( fidBvector, '%f[\t\n\r\f ]' );
    B(i,1) = log( element );
end

fclose( fidBvector );

initialPathCount = length(B);

% create  newG and new B ----------------------------------------------------

% fprintf('G matrix --------------------------------\n');
% disp( G );
% 
%  fprintf('B vector --------------------------------\n');
%  disp( B );

[Q, R, E] = qr( G' );

% fprintf( 'Q : \n' );
% disp(Q);
% 
% fprintf( 'R : \n' );
% disp(R);
% 
% fprintf( 'E : \n' );
% disp(E);

k = 1;
diag_R = diag( R );
size_E = size(E);
for i = 1 : length( diag_R )
    if diag_R( i,1 ) > 0.000001
        for j = 1 : size_E( 1 )
            if E( j, i ) == 1
                G2( k, : ) = G( j, : );
                B2( k, 1 ) = B( j, 1 );
                pathIndex( k ) = j - 1;
                k = k + 1;
            end
        end
    elseif diag_R( i, 1 ) < -0.000001
        for j = 1 : size_E( 1 )
            if E( j, i ) == 1
                G2( k, : ) = G( j, : );
                B2( k, 1 ) = B( j, 1 );
                pathIndex( k ) = j - 1;
                k = k + 1;
            end
        end
    end
end

% fprintf('G2 matrix --------------------------------\n');
% disp( G2 );
% 
% fprintf('B2 vector --------------------------------\n');
% disp( B2 );


% ---------------------------------------------------------------------

[Q2, R2, E2] = qr( G2 );
k = 1;
m = 1;
diag_R2 = diag( R2 );
size_E2 = size( E2 );
for i = 1 : length( diag_R2 )
    if diag_R2( i,1 ) > 0.000001
        for j = 1 : size_E2( 1 )
            if E2( j, i ) == 1
                G3( :, k ) = G2( :, j );
                linkIndex( k ) = j-1;
                k = k + 1;
            end
        end
    elseif diag_R2( i, 1 ) < -0.000001
        for j = 1 : size_E2( 1 )
            if E2( j, i ) == 1
                G3( :, k ) = G2( :, j );
                linkIndex( k ) = j-1;
                k = k + 1;
            end
        end
    end
end
% fprintf('\nInitial link count : %d\n', size_E2( 1 ) );
% fprintf('Number of link chosen : %d\n', k-1 );
initialLinkCount = size_E2( 1 );


% fprintf( 'Q2 : \n' );
% disp(Q2);
% 
% fprintf( 'R2 : \n' );
% disp(R2);
% 
% fprintf( 'E2 : \n' );
% disp(E2);
% 
% 
% 
% fprintf('G3 matrix --------------------------------\n');
% disp( G3 );
% 
% fprintf('B2 vector --------------------------------\n');
% disp( B2 );


newX = G3 \ B2;


if length( linkIndex ) ~= length( newX )
    fprintf( 'ERROR 00010 : Length of linkIndex vector and newX vector mismatch\n' );
    return;
end







% G' * X = B' 
B3 = G3 * newX;






% output B3 vector ----------------------------------------------------


fidWrite = fopen( '../../BRITE/topology/Bprime.out', 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file B3.out' );
end

fprintf( fidWrite, '%d\n', initialPathCount );
size_B3 = size( B3 );
fprintf( fidWrite, '%d\n', size_B3(1) );
for i = 1 : size_B3(1)
    fprintf( fidWrite, '%d\t%f\n', pathIndex(i), exp( B3(i) ) );
end

fclose( fidWrite );

