/**
 *OBJECT:	This class is used
 *				for an adjacency list representation of
 *				a Euclidian graph.
 *
 * @version    $Id: EuclidNode.java,v 1.1 12/26/2001
 *
 * @author    Mark Rabin
 *
 * Revisions:
 *     $Log: EuclidNode.java,v 1.1$
 *     Revision 1.1  12/26/2001
 *     Initial revision
 *
 */


// package LossyLink;


public class EuclidNode extends Node {
	int x, y;
	boolean relevantNode;

	/**
	* Constructor to initialize the node.
	*
	* @param id the identification number of the new node
	* @param x horizontal position
	* @param y vertical position
	*/
	public EuclidNode( int id, int x, int y ) {
		super( id );
		this.x = x;
		this.y = y;
		this.relevantNode = false;
	}

	/**
	* Compute the line-of-sight "crow's flight" distance.
	*
	* @return the straight-line distance to the goal
	*/
	public double goalEst( EuclidNode goal ) {
		//return Math.sqrt( Math.pow( Math.abs( goal.x - x ), 2 )
		//	+ Math.pow( Math.abs( goal.y - y ), 2 ) );
		return Math.max( x, y );
	}
}