function out = GetBprimeVector( outputBprimeVectorName, pathIndexList, linkIndexList, G, B3, newX );

% determine which path index is not computable
ii = 1;
while ii <= size( G, 1 )
    ret = IsComputablePath( pathIndexList, ii );
    if ret == 0

         % If this index of the path is not computable,
         % First, get its links
         linkSetInAPath = GetLinkSetInAPath( G, ii );
 
         % And then, get each link's loss rate
         % and do 1 - P = pi( 1 - L )
         kk = 1;
         invPathLossRate(ii) = 1;
         while kk <= length( linkSetInAPath )
             invPathLossRate(ii) = invPathLossRate(ii) * GetInvLinkLossRate( newX, linkIndexList, linkSetInAPath(kk) ); % 1 - P = pi( 1 - L )
             kk = kk + 1;
end
    else
        invPathLossRate(ii) = exp( B3(ret) );
    end
   
    ii = ii + 1;
end



% output invPathLossRate vector ----------------------------------------------------

fidWrite = fopen( outputBprimeVectorName, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', outputBprimeVectorName );
end

size_invPathLossRate = length( invPathLossRate );
fprintf( fidWrite, '%d\n', size_invPathLossRate );
for i = 1 : size_invPathLossRate
    fprintf( fidWrite, '%f\n', invPathLossRate(i) );
end

fclose( fidWrite );
