/**
 *OBJECT:	This class is used
 *				for Binary heap and Fibonacci heap
 *				priority queue.  It defines the atributes of
 *				a node in the heap.
 *
 * @version    $Id: HeapNode.java,v 1.1 12/26/2001
 *
 * @author    Mark Rabin
 *
 * Revisions:
 *     $Log: HeapNode.java,v 1.1$
 *     Revision 1.1  12/26/2001
 *     Initial revision
 *
 */


// package LossyLink;


public class HeapNode {

    int id;
    double value;

   /**
	* The constructor initializes a node in the
	*  heap.
	*
	* @param id the identification number of the new node
   * @parma value the current shortest path estimate
   */
    public HeapNode( int id, double value ) {
        this.id = id;
        this.value = value;
    }
	/**
	* Output the node values.
	*
	* @return the state of the node in string form
	*/
    public String toString() {
        if( value == Double.MAX_VALUE )
            return "(" + id + ", INF)";
        else
            return "(" + id + ", " + value + ")";
    }
}
