function LossyLink( inputScriptFile, isWindows )

% Open input script file --------------------------------------------------
fid = fopen( inputScriptFile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', inputScriptFile );
end

readEndFlag = 0;


while 1
    [strRead, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
    
    if readCount == 0
        break;
    end
    
    if strcmpi( strRead, 'outputFileName' ) == 1
        [strEqual, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000011 : Unexpected end of line');
            return;
        end
        
        [strValue, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );        
        if readCount == 0
            fprintf('ERROR 000012 : Can not read [%s] name from input script file [%s]', strValue, inputScriptFile );
            return;
        end
        
	strGfile    = strcat( strValue, '_G.out' );
        strGbarFile = strcat( strValue, '_Gbar.out' );
        strBbarFile = strcat( strValue, '_Bbar.out' );
        strRfile    = strcat( strValue, '_R.out' );
        strXfile    = strcat( strValue, '_X.out' );
        strBhatFile = strcat( strValue, '_Bhat.out' );
        readEndFlag = readEndFlag + 1;
   end
end

fclose( fid );

if readEndFlag ~= 1
    fprintf( 'ERROR 00002 : Input script file [%s] does not contain every information needed [%d]', inputScriptFile, readEndFlag );
    return;
end


% for MS Windows - Unix compatibility -------------------
if isWindows == 1
    strrep( strGfile, '/', '\\' );
    strrep( strGbarFile, '/', '\\' );
    strrep( strBbarFile, '/', '\\' );
    strrep( strRfile, '/', '\\' );
    strrep( strXfile, '/', '\\' );
    strrep( strBhatFile, '/', '\\' );
end

% for debug -------------------------------------------
fprintf( '%s\n%s\n', strGbarFile, strBbarFile );


% call appropriate functions -----------------------------

fprintf('calculate X -------------------------------------------------\n');
calculateX( strGfile, strGbarFile, strBbarFile, strRfile, strXfile, strBhatFile );

fprintf('LossyLink Terminated Normally. ----------------------------------------------------\n');













