/**
 * <p>Title: LossyLinkMeshReduced</p>
 * <p>Description: The <CODE>LossyLinkMeshReduced</CODE> class is used to compute the lossy links,
 * given the input of e2e loss and path</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


// package LossyLink;



import java.io.*;
import java.util.*;
import cluster.*;

public class LossyLinkMeshReduced implements Serializable, WNMMSConstants
{
    static LossyLink lossyLink;
    static String root;
    static String baseFilename;
    static HostMap rootMap;
    static PrintWriter errorStream;
    static LossyLinkData data;
    static boolean bReduceIP = false;
    static boolean bTest = false;
    static boolean bDebug = false;
    static boolean bReduceGraph = false;
    static boolean bLossProcessModel = false; //Default setting is BERNOULLI;
    ///////////////////////////////LossModel, Generate LossRate also changed.
    static LossyLinkPathInfo pathInfo;
    static LossyLinkBrite lossyLinkBrite;
    static String strBriteFile;
    static String strDateInput;
    static int iNumberOfHosts = 0;
    static String strSitesFile;
    static int iEndHostMaxDegree = -1;
    static int iEndHostCount = -1;
    static String strOutputFileName;
    static String strGmatrixFile;
    static String strBvectorFile;
    static String strLvectorFile;		//************** add by Jingo ************
    static String strTvectorFile;
    static String strCvectorFile;
    static String strIvectorFile;
    static String strVirGmatrixFile;
    static String strVirBvectorFile;
    static String strVirTvectorFile;
    static String strVinfoFile;
    static String strVfile;
    static String strGbarFile;
    static String strBbarFile;
    static String strPathIndexListFileName;
    static String strEndHostFile;
    static int iLossModel = 1;
    static String strLinkLossRateFile = "LinkLossRate.out";

    public static void main(String[] args)
    {
        int i = 0;
	int iTotalPathCount = 0;
        lossyLink = new LossyLink();
	data = new LossyLinkData();
	pathInfo = new LossyLinkPathInfo();

        int iStat[][] = new int[6][2];// iStat ----------------------------------------
                                     //                        Node_count  Link_count
                                     //  Initially             0,0         0,1
                                     //  After_pruning         1,0         1,1
                                     //  After_graph_reduction 2,0         2,1
                                     //  Total_path_count      3,0
                                     //  End_host_count                    3,1
                                     //  After_virtualization  4,0         4,1
                                     //  After_pre_graph_reduction 5,0         5,1
        parseInput( args );

/*
        lossyLinkBrite = new LossyLinkBrite();
        lossyLinkBrite.read( strBriteFile, data );

        int ixxx = data.degreeDistribution( 2, -1 );
        System.out.println("ixxx : " + ixxx );
        System.exit( 0 );
*/



        System.out.println("readGmatrix -----------------------------------");
        pathInfo.readGmatrix( strGmatrixFile, data.link, iStat[3] );

        System.out.println("\nAssign Loss Rates ----------------------------------");
        LossyLinkModel lossyLinkModel = new LossyLinkModel( iLossModel );
	lossyLinkModel.readLossyLink( data.link, strLinkLossRateFile );
	//lossyLinkModel.GenerateLossyLink( data.link );

        System.out.println("\nOutput Data Preparation -------------------------" );
	pathInfo.GenerateBvector( data, bLossProcessModel );
        System.out.println("\nsaveBvector -------------------------" );
       pathInfo.saveBvector( strBvectorFile );
	pathInfo.saveLvector( strLvectorFile );	//************** add by Jingo ************

    // stat ------------------------------------------------------------------------------------
/*
            System.out.println( args[0].substring( 0, args[0].indexOf(".") ) + " " + iStat[3][1] + " end hosts ----------------------------------" );
            System.out.println("Initially\t\t\t" + "node: " + iStat[0][0] + "\t" + "link:" + iStat[0][1] );
            System.out.println("After pruning\t\t" + "node: " + ( iStat[0][0] - iStat[5][0] + iStat[1][0] ) + "\t" + "link:" + ( iStat[0][1] - iStat[5][1] + iStat[1][1] ) );
            System.out.println("After graph reduction\t" + "node: " + iStat[2][0] + "\t" + "link:" + iStat[2][1] );
            System.out.println("# of path : \t\t" + iStat[3][0] );
            System.out.println("\t# of inferred links (rank) : \t\t" );
            System.out.println("\t# of unidentifiable links : \t\t" );
            System.out.println("After virtualization \t" + "node: " + iStat[4][0] + "\t" + "link:" + iStat[4][1] );
            System.out.println("\t# of inferred links (rank) : \t\t" );
            System.out.println("\t# of unidentifiable links : \t\t" );
*/
            System.out.println("OriginalLinkCount : " + iStat[3][0] );
            System.out.println("LinkCountAfterPruning : " + iStat[3][1] );

    // -------------------------------------------------------------------------------------------
/*
         pathInfo.readIvector( strIvectorFile );

         System.out.println("\nsave G bar matrix -------------------------" );
         pathInfo.saveGmatrix( strGbarFile, data.link );
         System.out.println("\nsave B bar vector -------------------------" );
         pathInfo.saveBvector( strBbarFile );
         System.out.println("\nLLMR DONE" );
*/    }



    private static void showUsage()
    {
	System.err.println("\nUsage: \njava LossyLinkMeshReduced " +
			   "<date> <number_of_hosts> <sites_file> [OPTION]\n"+
			   "or java LossyLinkMeshReduced <BRITE_file> [OPTIION]\n"+
                           "or java LossyLinkMeshReduced <Input_script_file>\n"+
			   "\ni.e. java LossyLinkMeshReduced 102.11.1 111 newsites.lst -ar" +
			   "\ni.e. java LossyLinkMeshReduced ../BRITE/topology/ASBarabasi100U.brite -ar -m2" +
                           "\ni.e. java LossyLinkMeshReduced ASBarabasi100U.input" +
			   "\n\nOption: "+
			   "\n\t-a\tAggregate IP address length to 29 bit instead of 32."+
			   "\n\t  \tThis option is only applied to *.trace input files." +
			   "\n\t-r\tReduce graph."+
			   "\n\t-m###\tMaximum degree of end hosts." +
			   "\n\t  \tEvery node is considered as end hosts if not stated." +
			   "\n\t  \tThis option is only applied to BRITE input files." +
                           "\n\t-c###\tEnd host count." +
                           "\n\t  \tEvery node is considered as end hosts if not stated." +
                           "\n\t  \tThis option is only applied to BRITE input files." +
                           "\n\t  \t-m and -c options can not be specified at the same time. The latter will be ignored." +
                           "\n\nNotes: "+
			   "\n\tTemporary output files are <BRITE_file>_A.out, <BRITE_file>_X.out, <BRITE_file>_T.out, and LossyLinkDegree.out" );
    }


    private static int initialize( String strDateInput, String strSitesFile )
    {
	baseFilename = ".." + SLASH + "data" + SLASH + "raw-data" + SLASH + strDateInput + SLASH;
	rootMap = new HostMap( strSitesFile, iNumberOfHosts );

	return 1;
    }



    private static void parseInput( String args[] )
    {
        if( args.length != 1 )
        {
            System.err.println("ERROR : Too many arguments");
            showUsage();
            System.exit( 0 );
        }

        //input script file
        parseInputScriptFile( args[0] );
	LossyLinkDebug.setDebug(bDebug);

        LossyLinkDebug.println( "\nInternal flags info -------------------\n" +
                                "\tbReduceIP["+bReduceIP+"]\n"+
                                "\tbReduceGraph["+bReduceGraph+"]\n"+
                                "\tbTest["+bTest+"]\n"+
                                "\tbDebug["+bDebug+"]\n");
    }





    /* Input file features
       // 
              Description : Comment

       ReduceGraph
              Type : Boolean. 
	      Default : false.
	      Description : Set 'true' to perform Graph Reduction.

       Test
              Type : Boolean. 
	      Default : false.
	      Description : Set 'true' to run in test mode. Deprecated.

       Debug
              Type : Boolean.
	      Default : false.
	      Description : This command prints out debug messages coded in LossyLinkDebug.println() function when set to 'true'.
       
       OutputFileName
              Type : String.
	      Default : Creates G,B,T,I,Bbar files using current time and date as their file name in current directory.
	      Description : This command specifies a directory and file name for G,B,T,I,Bbar files.

       BriteFile
              Type : String.
	      Default : N/A. Must be given to use BRITE synthetic topology.
	      Description : This command specifies a directory and file name for .BRITE file to be used in BRITE synthetic topology.
       
       MaximumDegreeOfEndHosts
              Type : Integer.
	      Default : N/A. 
	      
    */
    private static void parseInputScriptFile( String strFileName )
    {
        String strLine;
        System.out.println("InputFileName : "+strFileName );
        try
        {
            BufferedReader inputScriptReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strFileName))));

            for( int i = 0; ( strLine = inputScriptReader.readLine() ) != null; ++i )
            {
                StringTokenizer st = new StringTokenizer( strLine, "\t\n\r= " );

                //loop for every token
                String strDefinition = null;
                String strValue = null;
                String strToken = null;
                while( st.hasMoreTokens() )
                {
                    strToken = st.nextToken();

                    //Ignore comments
                    if( strToken.startsWith( "//" ) == true )
                    {
                        break;
                    }

                    //Store script file fields into strDefinition and strValue
                    if( strDefinition == null )
                    {
                        strDefinition = strToken;
                        continue;
                    }
                    strValue = strToken;
                    if( strValue.length() == 0 )
                    {
                        System.err.println("ERROR LLMR 00121 : No value specified for " + strDefinition + " field" );
                        showUsage();
                        System.exit( 0 );
                    }
                    LossyLinkDebug.println("strDefinition : " + strDefinition );
                    LossyLinkDebug.println("strValue : " + strValue );

                    //Common section for both BRITE and Trace files.
		    if( strDefinition.compareToIgnoreCase( "ReduceGraph" ) == 0 )
                    {
                        if( strValue.compareTo( "1" ) == 0 )
                        {
                            bReduceGraph = true;
                        }
                        break;
                    }
                    else if( strDefinition.compareToIgnoreCase( "Test" ) == 0 )
                    {
                        if( strValue.compareTo( "1" ) == 0 )
                        {
                            bTest = true;
                        }
                        break;
                    }
                    else if( strDefinition.compareToIgnoreCase( "Debug" ) == 0 )
                    {
                        if( strValue.compareTo( "1" ) == 0 )
                        {
                            bDebug = true;
                        }
                        break;
                    }
                    else if( strDefinition.compareToIgnoreCase( "OutputFileName" ) == 0 )
                    {
                        strOutputFileName = strValue;
                        strGmatrixFile = strValue + "_G.out";
                        strBvectorFile = strValue + "_B.out";
                        strLvectorFile = strValue + "_L.out";		//************** add by Jingo ************
                        strTvectorFile = strValue + "_T.out";
                        strCvectorFile = strValue + "_C.out";
                        strIvectorFile = strValue + "_I.out";
                        strVirGmatrixFile = strValue + "_virG.out";
                        strVirBvectorFile = strValue + "_virB.out";
                        strVirTvectorFile = strValue + "_virT.out";
                        strVinfoFile = strValue + "_Vinfo.out";
			   strVfile = strValue + "_V.out";
                        strGbarFile = strValue + "_Gbar.out";
                        strBbarFile = strValue + "_Bbar.out";
                        strPathIndexListFileName = strValue + "_pathID.out";
                        strEndHostFile = strValue + "_EndHosts.out";
                        break;
                    }


		    if( strDefinition.compareToIgnoreCase( "BriteFile" ) == 0 )
                    {
			strBriteFile = strValue;
			break;
                    }
		    else if( strDefinition.compareToIgnoreCase( "MaximumDegreeOfEndHosts" ) == 0 )
                    {
			iEndHostMaxDegree = Integer.parseInt( strValue );
			break;
                    }
		    else if( strDefinition.compareToIgnoreCase( "EndHostCount" ) == 0 )
                    {
			if( iEndHostMaxDegree != -1 )
			{
			    System.err.println("WARNING LLMR 00123 : MaximumDegreeOfEndHosts and EndHostCount can not be used at a same time. Ignoring the latter" );
			}
			iEndHostCount = Integer.parseInt( strValue );
			break;
                    }

		    //for loss model
		    if( strDefinition.compareToIgnoreCase( "LossModel" ) == 0 )
		    {
			iLossModel = Integer.parseInt( strValue );
			if( iLossModel < 1 || iLossModel > 2 )
			{
			    System.err.println("ERROR LLMR 01101 : LossModel = "+strValue+" in "+strFileName+" is not a valid command." );
			    System.exit(0);
			}
		    }
		    
		    //for loss process
		    if( strDefinition.compareToIgnoreCase( "LossProcessModel" ) == 0 )
		    {
                        if( strValue.compareToIgnoreCase( "Gilbert" ) == 0 )
                        {
                            bLossProcessModel = true; //bLossProcessModel : false is Bernoulli, true is Gilbert. 
                        }
			else if( strValue.compareToIgnoreCase( "Bernoulli" ) == 0 )
			{
			    bLossProcessModel = false;
			}
			else
			{
			    System.err.println("WARNING LLMR 01100 : LossProcessModel = "+strValue+" in "+strFileName+" is not a valid command." );
			    System.exit(1);
			}
			//			bLossProcessModel = true; /////////////////////////////////////////////////////////////////////////////////////REMOVE THIS 
                        break;
		    }
                }//end while
            }//end for
            inputScriptReader.close();
        }
        catch (IOException e)
        {
            System.err.println( "LossyLinkMeshReduced : File not opened properely\n" + e.toString());
            showUsage();
            System.exit(1);
        }
    }
}

