

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


// package LossyLink;


import java.io.*;
import java.util.*;
//package lossylink;

public class LossyLinkModel
{
    public double dGoodLinkRate = -1.0;

    public double dGoodLinkLossRateMin = -1.0;
    public double dGoodLinkLossRateMax = -1.0;
    public double dBadLinkLossRateMin = -1.0;
    public double dBadLinkLossRateMax = -1.0;

    private double dGoodLinkLossRate = -1.0;
    private double dBadLinkLossRate = -1.0;

    public LossyLinkModel( int iLossModel )
    {
        //dGoodLinkRate = 0.5;
        dGoodLinkRate = 0.9;

	
	if( iLossModel == 1 )
	{
	    //LM1
	    System.out.println("LossModel1(0.05~0.10 lossy) selected");
	    dGoodLinkLossRateMin = 0.00;//LM1
	    dGoodLinkLossRateMax = 0.01;//LM1
	    dBadLinkLossRateMin = 0.05;//LM1
	    dBadLinkLossRateMax = 0.10;//LM1
	}
        else if( iLossModel == 2 )
	{
	    //LM2
	    System.out.println("LossModel2(0.1~1.0 lossy) selected");
	    dGoodLinkLossRateMin = 0.00;//LM2
	    dGoodLinkLossRateMax = 0.01;//LM2
	    dBadLinkLossRateMin = 0.01;//LM2
	    dBadLinkLossRateMax = 1.00;//LM2
	}
	else
	{
	    System.out.println("LLM ERROR : Incorrect Loss Model specification." );
	    System.exit(0);
	}
    }

    public void readLossyLink( LossyLinkLink link, String fileName )
    {
	// read from fileName to get the loss rate to assign to each link
	//open file ()
	
	BufferedReader br = null;
	double rows = 0;
	int iLinkCount = link.count();

	try{

	    br = new BufferedReader(new FileReader(fileName));
	    
	}
	catch(IOException e){

	    System.err.println("Error LossyLinkModel::readLossyLink could not open file" + fileName );
	    System.exit(0);
	}
	
	//LinkLossRate.out
	//Read the input file
	try{
	    rows = Double.parseDouble( br.readLine() );

	    for( int i = 0; i < iLinkCount; ++i )
	    {
		link.setLossRate( i, Double.parseDouble( br.readLine() ) );
	    }
	    System.out.println("done reading " + iLinkCount );

	}
	catch(Exception e){
	    System.err.println("Error LossyLinkModel::readLossyLink bad input format" + fileName );
	    System.exit(0);
	}

	try{
	    br.close();
	}
	catch(Exception e){
	    System.err.println("Error closing file stream.");
	}
	
	
    }
    

    public void GenerateLossyLink( LossyLinkLink link )
    {
	//Specify good link loss rates
	int iLinkCount = link.count();
	int iGoodLinkCount = (int)( dGoodLinkRate * iLinkCount );
	int iLinkIndex = 0;



        //for debug
        for( int i = 0; i < iLinkCount; ++i )
        {
          link.setLossRate( i, -1.0 );
        }


	for( int i = 0; i < iGoodLinkCount; ++i )
	{
	    iLinkIndex = (int)( Math.random() * iLinkCount -1 );
            LossyLinkDebug.println("iLinkIndex = (int)( Math.random() * ( iLinkCount-1 ) )\t" + iLinkIndex + " " + iLinkCount );
            while( link.getLossRate( iLinkIndex ) != -1.0 )
            {
                iLinkIndex = (int)( Math.random() * iLinkCount -1 );
            }
            dGoodLinkLossRate = ( Math.random() * dGoodLinkLossRateMax ) + dGoodLinkLossRateMin;
            LossyLinkDebug.println("dGoodLinkLossRate : iLinkIndex : " + iLinkIndex + " LossRate : " + dGoodLinkLossRate );
            if( dGoodLinkLossRate > 1.0 )
            {
                System.out.println( "ERROR 00100" );
		System.exit( 1 );
            }
	    link.setLossRate( iLinkIndex, dGoodLinkLossRate  );
	}

	//Specify bad link loss rates
        int j = 0;
        for( int i = 0; i < iLinkCount; ++i )
	{
	    if( link.getLossRate( i ) == -1.0 ) //if no loss rate specified.
	    {
                dBadLinkLossRate = ( Math.random() * ( dBadLinkLossRateMax - dBadLinkLossRateMin ) ) + dBadLinkLossRateMin;
                LossyLinkDebug.println("dBadLinkLossRate : iLinkIndex : " + i + " LossRate : " + dBadLinkLossRate );
		link.setLossRate( i, dBadLinkLossRate );
	//	System.out.println("link " + i + " with loss " + link.getLossRate( i ));
                j++;
	    }
	    
	    //**************** added by jingo***************
//           if( link.getLossRate( i ) > dGoodLinkLossRateMax && link.getLossRate( i ) < dBadLinkLossRateMin)
//		 System.out.println("link " + i + " has abnormal loss of " + link.getLossRate( i ));

	}

	System.out.println("Number of bad link : " + j);

        if( j != iLinkCount - iGoodLinkCount )
        {
            System.out.println( "ERROR 00120 : # of bad links not correct. [" + j + "], should be [" + (iLinkCount - iGoodLinkCount) + "]" );
            System.exit( 1 );
        }
    }

///??? for debug?
    public void countLossyLink( LossyLinkData data )
    {
	int iLinkCount = data.link.count();
        int iLossyLinkCount = 0;
        int iGoodLinkCount = 0;

        for( int i = 0; i < iLinkCount; ++i )
        {
            if( data.link.getLossRate( i ) >= dBadLinkLossRateMin
               && data.link.getLossRate( i ) < dBadLinkLossRateMax )
            {
                iLossyLinkCount++;
            }
	    else
            {
		iGoodLinkCount++;
	    }
        }

        return;
    }



}












