/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.io.*;
import java.util.*;

public class LossyLinkPathErrorRate
{
  static int UNCOMPUTABLE = 99999;
  static LossRateData truePath;
  static LossRateData inferredPath;

  static int iTruePathCount = 0;
  static int iInferredPathCount = 0;

  static String strGmatrixFile;
  static String strBvectorFile;
  static String strCvectorFile;
  static String strTvectorFile;
  static String strXvectorFile;

  static int iGmatrix[][];
  static double dTvector[];
  static double dXvector[];

  public LossyLinkPathErrorRate()
  {
    init();
  }

  static private void init()
  {
  }

  public static void main(String[] args)
  {
    parseInput( args );


    System.out.println("\n1. Evaluate ["+strBvectorFile+"] ["+strCvectorFile+"]" );
    {
      openGmatrix( strGmatrixFile );
      openTvector( strTvectorFile );
      openXvector( strXvectorFile );
      openBvector(strBvectorFile);
//      openCalculatedBvector( strCvectorFile );
      calculatePathLossRate();
      compareBtoC();
    }
  }


    public static void openGmatrix( String strGmatrixFile )
    {
      int iRowCount = 0;
      int iColCount = 0;
      int iNonzeroCount = 0;
      try
      {
        BufferedReader gMatrixFileReader = new BufferedReader(new
            InputStreamReader(new FileInputStream(new File(strGmatrixFile))));

        String strTmp;
        if ( (strTmp = gMatrixFileReader.readLine()) != null)
        {
          iRowCount = Integer.parseInt(strTmp);
        }
        if ( (strTmp = gMatrixFileReader.readLine()) != null)
        {
          iColCount = Integer.parseInt(strTmp);
        }
        if ( (strTmp = gMatrixFileReader.readLine()) != null)
        {
          iNonzeroCount = Integer.parseInt(strTmp);
        }
        iGmatrix = new int[iRowCount][iColCount];

        for ( int i = 0; i < iRowCount; i++ )
        {
          int iNonzeroCountInARow = 0;

          strTmp = gMatrixFileReader.readLine();
          StringTokenizer st = new StringTokenizer( strTmp, "\t\n\r\f " );
          if( st.hasMoreTokens() == true )
          {
            iNonzeroCountInARow = Integer.parseInt( st.nextToken() );
          }

          int iNextIndex = 0;
          for( int j = 0; j < iNonzeroCountInARow; j++ )
          {
            iNextIndex = Integer.parseInt( st.nextToken() );
            iGmatrix[i][iNextIndex] = 1;
          }
        }
      }
      catch (IOException e) {
        System.err.println("LossyLinkPathLossRate : File not opened properely\n" +
                           e.toString());
        System.exit(1);
      }
    }



    public static void openTvector( String strTvectorFile )
    {
      int iRowCount = 0;
      try
      {
        BufferedReader tVectorFileReader = new BufferedReader
            (new InputStreamReader(new FileInputStream(new File(strTvectorFile))));

        String strTmp;
        if ( (strTmp = tVectorFileReader.readLine()) != null)
        {
          iRowCount = Integer.parseInt(strTmp);
        }
        dTvector = new double[iRowCount];

        for ( int i = 0; i < iRowCount; i++ )
        {
          int iNonzeroCountInARow = 0;

          strTmp = tVectorFileReader.readLine();
          dTvector[i] = Double.parseDouble( strTmp );
        }
      }
      catch (IOException e) {
        System.err.println("LossyLinkPathLossRate : File not opened properly\n" +
                           e.toString());
        System.exit(1);
      }
    }

    public static void openXvector( String strXvectorFile )
    {
      int iArrSize = 0;
      int iComputableLinkCount = 0;
      try
      {
        BufferedReader xVectorReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strXvectorFile))));

        String strTmp;
        //first line in X file indicates initial link count
        if( ( strTmp = xVectorReader.readLine() ) != null )
        {
          iArrSize = Integer.parseInt( strTmp );
        }
        //second line in X file indicates computable link count
        if( ( strTmp = xVectorReader.readLine() ) != null )
        {
          iComputableLinkCount = Integer.parseInt( strTmp );
          if( iArrSize < iComputableLinkCount )
          {
            System.err.println("ERROR LLLR 00200 : Total link in topology < Computable link count" );
            System.exit( 0 );
          }
        }
        else
        {
          System.err.println("ERROR LLLR 00400 : Can not read input file ["+strXvectorFile+"]");
          System.exit(0);
        }

        dXvector = new double[iArrSize];

        for( int i = 0; i < iArrSize; ++i )
        {
          dXvector[i] = UNCOMPUTABLE;
        }

        for( int i = 0; i < iComputableLinkCount; ++i )
        {
          if ( (strTmp = xVectorReader.readLine()) == null)
          {
            System.err.println("ERROR LLLR 00903");
            System.exit(0);
          }
          int iDelimeter = strTmp.lastIndexOf( "\t" );
          int iIndex = Integer.parseInt( strTmp.substring( 0, iDelimeter ) );
          if( dXvector[iIndex] != UNCOMPUTABLE )
          {
            System.err.println("ERROR LLLR 00907");
            System.exit( 0 );
          }
          dXvector[iIndex] = Double.parseDouble( strTmp.substring( iDelimeter + 1 ) );

        }

        xVectorReader.close();
      }
      catch (IOException e)
      {
        System.err.println( "LossyLinkLossRate : File not opened properely\n" + e.toString());
        System.exit(1);
      }
    }

  public static int openBvector(String strTrueFileName)
  {
    int iArrSize = 0; //Total link count in the topology.
    int iComputablePathCount = 0; //Computable link count, iComputableLinkCount <= iArrSize

    if (strTrueFileName == null ) {
      System.out.println("ERROR 00001");
      return -1;
    }

    try {
      BufferedReader trueLossRateReader = new BufferedReader(new
          InputStreamReader(new FileInputStream(new File(strTrueFileName))));

      String strTmp;
      if ( (strTmp = trueLossRateReader.readLine()) != null) {
        iArrSize = Integer.parseInt(strTmp);
        truePath = new LossRateData(iArrSize);
      }
      else {
        System.err.println("ERROR LLLR 00400 : Can not read input file [" +
                           strTrueFileName + "]");
        System.exit(0);
      }

      int i = 0;
      for (i = 0;
           i < truePath.iCount && ( (strTmp = trueLossRateReader.readLine()) != null);
           ++i) {
        truePath.dLossRate[i] =  1 - Double.parseDouble(strTmp);
      }
      trueLossRateReader.close();
      iTruePathCount = truePath.iCount;
    }
    catch (IOException e) {
      System.err.println("LossyLinkPathLossRate : File not opened properely\n" +
                         e.toString());
      System.exit(1);
    }
    return truePath.iCount;
  }
    // ----------------------------------------------

  public static int openCalculatedBvector( String strInferredFileName )
  {
    int iArrSize = 0; //Total link count in the topology.
    int iComputablePathCount = 0; //Computable link count, iComputableLinkCount <= iArrSize

    if (strInferredFileName == null ) {
      System.out.println("ERROR 00001");
      return -1;
    }

    try {
      BufferedReader inferredLossRateReader = new BufferedReader(new
          InputStreamReader(new FileInputStream(new File(strInferredFileName))));

      String strTmp;
      //first line in X file indicates initial link count
      if ( (strTmp = inferredLossRateReader.readLine()) != null) {
        iComputablePathCount = iArrSize = Integer.parseInt(strTmp);
        inferredPath = new LossRateData(iArrSize);
      }
      else {
        System.err.println("ERROR LLLR 00400 : Can not read input file [" +
                           strInferredFileName + "]");
        System.exit(0);
      }

      for (int i = 0; i < iComputablePathCount && ( (strTmp = inferredLossRateReader.readLine()) != null); ++i) {
        inferredPath.dLossRate[i] = Math.log( Double.parseDouble(strTmp) );
      }

      inferredLossRateReader.close();
    }
    catch (IOException e) {
      System.err.println("LossyLinkLossRate : File not opened properely\n" +
                         e.toString());
      System.exit(1);
    }


    return inferredPath.iCount;
  }

  public static int compareBtoC()
  {
    int iCoverage = 0;
    LossyLinkDebug.println("\t\n\ncompare 'Simulated Path Loss Rate' vector to 'Calculated Path Loss Rate' vector --------------------");
    if (truePath.iCount != inferredPath.iCount) {
      System.out.println(
          "\tERROR LLLR 00058 : Dimension mismatch between B and C vectors.");
      System.out.println("\tMaybe you forgot to process in MATLAB?");
      return 0;
    }
    //Find average and maximum difference
    double dMaxDiff = 0;
    double dTemp = 0;
    double dDiffElement[] = new double[iTruePathCount];
    double dDiff = 0;
    int iCount = 0;
    for (int i = 0; i < iTruePathCount; ++i) {
      dTemp = ( truePath.dLossRate[i] - inferredPath.dLossRate[i] );
      dDiff = dDiff + Math.abs( dTemp );
      dDiffElement[i] = Math.abs( dTemp );
      if ( Math.abs( dTemp ) > Math.abs( dMaxDiff ) )
      {
        dMaxDiff = dTemp;
      }
//      if( Math.abs( dTemp ) > 0.02 )
      {
        System.out.println("["+i+"] "+"diff = "+ rounding( dTemp, 3 ) +
                           "\tOrig : "+ rounding( truePath.dLossRate[i], 3 )+
                           "\tInf : "+ rounding( inferredPath.dLossRate[i], 3 ) );
        iCount++;
      }
    }
    dDiff = dDiff / iTruePathCount;
    System.out.println("\tCount : " + iCount);
    Arrays.sort( dDiffElement );

    System.out.println("\t\nResult of comparing 'Simulated Path Loss Rate' vector to 'Calculated Path Loss Rate' vector --------------------");
    System.out.println("\tTotal path count : " + iTruePathCount);
    System.out.println("\tAverage difference : " + rounding( dDiff, 3 ));
    System.out.println("\tMaximum difference : " + rounding( dMaxDiff, 3 ));
    System.out.println("\tMedian : " + rounding( dDiffElement[iTruePathCount/2], 3 ));

    return 1;
  }

  public static int calculatePathLossRate()
  {
    inferredPath = new LossRateData(iGmatrix.length);

    for( int i = 0; i < iGmatrix.length; i++ )
    {
      double dPathLossRate = 0;
      int iLinkCountInAPath = 0;
      for( int j = 0; j < iGmatrix[0].length; j++ )
      {
        if( iGmatrix[i][j] == 1 )
        {
          dPathLossRate = dPathLossRate + dXvector[j];
          iLinkCountInAPath++;
        }
      }
      dPathLossRate = 1 - Math.exp( dPathLossRate );
      inferredPath.dLossRate[i] = dPathLossRate;
      iInferredPathCount++;
    }

    return 1;
  }


  public static String rounding(double dNumber, int point) {
    String strNumber = Double.toString(dNumber);
    if ( (strNumber.indexOf("E") != -1)
        || (strNumber.indexOf("NaN") != -1)
        || (strNumber.indexOf("Inf") != -1)) {
      return strNumber;
    }
    int iDelimeter = strNumber.lastIndexOf(".");
    int iOffset = iDelimeter + point + 1;
    if (iOffset > strNumber.length()) {
      iOffset = strNumber.length();
    }
    return strNumber.substring(0, iOffset);
  }




  public static void parseInput( String args[] )
  {
      if( args.length != 1 )
      {
          System.err.println("ERROR LLLR 00301 : Wrong arguments.");
          System.exit(0);
      }

      if (args[0].indexOf(".input") != -1)
      {
          parseInputScriptFile(args[0]);
      }
  }

  public static void parseInputScriptFile( String strFileName )
  {
      String strLine;
      try
      {
          BufferedReader inputScriptReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strFileName))));

          for( int i = 0; ( strLine = inputScriptReader.readLine() ) != null; ++i )
          {
              StringTokenizer st = new StringTokenizer( strLine, "\t\n\r= " );

              //loop for every token
              String strDefinition = null;
              String strValue = null;
              String strToken = null;
              while( st.hasMoreTokens() )
              {
                  strToken = st.nextToken();

                  //Ignore comments
                  if( strToken.startsWith( "//" ) == true )
                  {
                      break;
                  }

                  //Store script file fields into strDefinition and strValue
                  if( strDefinition == null )
                  {
                      strDefinition = strToken;
                      continue;
                  }
                  strValue = strToken;
                  if( strValue.length() == 0 )
                  {
                      System.err.println("ERROR LLLR 00121 : No value specified for " + strDefinition + " field" );
                      System.exit( 0 );
                  }
                  LossyLinkDebug.println("strDefinition : " + strDefinition );
                  LossyLinkDebug.println("strValue : " + strValue );

                  if( strDefinition.compareToIgnoreCase( "outputFileName" ) == 0 )
                  {
                      strGmatrixFile = strValue + "_VirG.out";
                      strBvectorFile = strValue + "_VirB.out";
                      strTvectorFile = strValue + "_VirT.out";
                      strXvectorFile = strValue + "_virNewX.out";
                      strCvectorFile = strValue + "_C.out";
                      break;
                  }
                  else if( strDefinition.compareToIgnoreCase( "Debug" ) == 0 )
                  {
                      if( strValue.compareTo( "1" ) == 0 )
                      {
                          LossyLinkDebug.setDebug( true );
                      }
                      break;
                  }
              }//end while
          }//end for
          inputScriptReader.close();
      }
      catch (IOException e)
      {
          System.err.println( "LossyLinkLossRate : File not opened properely\n" + e.toString());
          System.exit(1);
      }
  }
}

