// package LossyLink;

/**
 * <p>Title: LossyLinkPathInfo</p>
 * <p>Description: The <CODE>LossyLinkPathInfo</CODE> class is used in reporting
 * average number of links per path and median of links.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


// package LossyLink;

import java.io.*;
import java.util.*;
import cluster.*;




public class LossyLinkPathInfo// implements Serializable, WNMMSConstants
{
    Hashtable srcDstHost;
    int iGmatrix[][];
    LossyLinkPathData pathList[];
    int iPathListCount;
    int iLinkDataMax;
    int iLinkListCount;		//************** add by Jingo ************

    double B[];
    double L[];		//************** add by Jingo ************
//    Vector uncoveredLinkList = new Vector();


    public LossyLinkPathInfo()
    {
        srcDstHost= new Hashtable();
        iLinkDataMax = 0;
        iPathListCount = 0;
    }

/*
    public int condensePathInfo( LossyLinkNode node )
    {
      Vector newPathList = new Vector( srcDstHost.size() );
      newPathList.setSize( srcDstHost.size() );
      int iSrcHost = -1;
      int iDestHost = -1;
      int pathIndexListCount = 0;
      int pathIndexList[] = new int[pathList.size()];
      LossyLinkPathData pathData;
      LossyLinkNodeData nodeData;

      int a = 0;
      int b = 0;
      int iCounter = 0;
      for( int i = 0; i < pathList.size(); i++ )
      {
        pathData = (LossyLinkPathData)pathList.get(i);
        iSrcHost = pathData.getSrcHost();
        nodeData = (LossyLinkNodeData)node.nodeTable.get( new Integer( iSrcHost ) );
        iSrcHost = nodeData.iOriginalIndex;
        iDestHost = pathData.getDestHost();
        nodeData = (LossyLinkNodeData)node.nodeTable.get( new Integer( iDestHost ) );
        iDestHost = nodeData.iOriginalIndex;

        //System.out.println( "src:" + iSrcHost + " dst:" + iDestHost );

        Object objSrcDstIndex = new Object();
        if( ( objSrcDstIndex = srcDstHost.get( new Integer( iSrcHost*10000 + iDestHost ) ) ) == null &&
            ( objSrcDstIndex = srcDstHost.get( new Integer( iDestHost*10000 + iSrcHost ) ) ) == null )
        { //not added to new path list
          //pathList.removeElementAt(i);
          //i--;
          a++;
        }
        else
        { //added to new path list
          //pathIndexList[pathIndexListCount++] = iCounter;
          newPathList.set( ((Integer)objSrcDstIndex).intValue(), pathList.get(i) );
          //System.out.println( "added src:" + iSrcHost + " dst:" + iDestHost );
          b++;
        }
        //iCounter++;
      }
      pathList = newPathList;

      System.out.println("Not added to new list : " + a + " Added to new list : " + b + " newPathListLength : " + pathList.size() );

      return 1;
    }
*/
    public void addLinkInPath( int iPathInfoIndex, int iLinkIndex )
    {
	LossyLinkPathData pathData;
	pathData = (LossyLinkPathData)pathList[iPathInfoIndex];
	pathData.addLinkIndex( iLinkIndex );
    }

    public int newLinkInPath( int iLinkIndexListCount )
    {
	LossyLinkPathData pathData = new LossyLinkPathData( iLinkIndexListCount );
        pathList[iPathListCount] = pathData;
        iPathListCount++;
//	System.out.println("PathInfo() newLinkData() idx : " + ( pathList.size() - 1 ) + "iSrcHostIndex : " + iSrcHostIndex + " iDestHostIndex : " + iDestHostIndex );
	return iPathListCount-1;
    }


/*
    public int getIndex( int iSrcHostIndex, int iDestHostIndex )
    {
	if( iSrcHostIndex == iDestHostIndex )
	    {
		return -1;
	    }


	int iPathListLen = 0;
	LossyLinkPathData pathData;

	iPathListLen = pathList.size();
	for( int i = 0; i < iPathListLen; ++i )
	    {
		pathData = (LossyLinkPathData)pathList.get( i );
		if( iSrcHostIndex == pathData.getSrcHost()
		    && iDestHostIndex == pathData.getDestHost() )
		    {
			return i;
		    }
	    }
	return -1;
    }
*/

/*
    public void removeInternalNode( LossyLinkData data )
    {
	Vector newPathList = new Vector();
	LossyLinkPathData pathData;
	int iPathListLen = getTotalPathCount();
	for( int i = 0; i < iPathListLen; ++i )
	{
	    pathData = (LossyLinkPathData)pathList.get( i );
	    if( data.node.isEndHost( pathData.getSrcHost() ) == 1
	     && data.node.isEndHost( pathData.getDestHost() ) == 1 )
	    {
		newPathList.add( pathList.get( i ) );
	    }
	    //LossyLinkDebug.println( "removeInternalNode: this node is internal, removed src : " + pathData.getSrcHost() + " dest: " + pathData.getDestHost() );
	}
	pathList = newPathList;

//for debug
        if( LossyLinkDebug.isDebug() )
        {
           for( int i = 0; i < getTotalPathCount(); ++i )
           {
               LossyLinkPathData pathDataToo = (LossyLinkPathData) pathList.get(i);;
               LossyLinkDebug.print("O Src:" + pathDataToo.getSrcHost() + " Dest:" +
		    		 pathDataToo.getDestHost() + " iCount:" + pathDataToo.iCount );
               for (int j = 0; j < pathDataToo.linkIndexList.size(); j++)
               {
		    LossyLinkDebug.print(" [" + pathDataToo.linkIndexList.get(j) + "]");
	       }
    	       LossyLinkDebug.println("-------");
            }
        }
//end debug
    }
*/
/*
    public int removeOppositePath( LossyLinkData data )
    {
        if( data.link.getLinkType() != data.link.UNDIRECTED )
        {
            LossyLinkDebug.println("PathInfo : removeOppositeLink() called but not executed - not UNDIRECTED" );
            return 0;
        }
        int iOppositePathIndex = -1;
        int iNodeCount = data.node.count();
        Vector newPathList = new Vector();
        LossyLinkPathData pathData;
//	int iPathListLen = getTotalPathCount();

        for( int i = 0; i < getTotalPathCount(); ++i )
        {
            pathData = (LossyLinkPathData)pathList.get( i );
            iOppositePathIndex = ( iNodeCount - 1 ) * pathData.getDestHost() + pathData.getSrcHost();// + 1;
            if( iOppositePathIndex < i )
            {
                iOppositePathIndex -= 1;
            }

//for debug
            if( LossyLinkDebug.isDebug() )
            {
                LossyLinkDebug.print( "P Src:" + pathData.getSrcHost() + " Dest:" + pathData.getDestHost() );
                for( int j = 0; j < pathData.linkIndexList.size(); j++ )
                {
                    LossyLinkDebug.print( " [" + pathData.linkIndexList.get(j) + "]");
                }
                LossyLinkDebug.println("");

                LossyLinkPathData pathDataToo = (LossyLinkPathData)pathList.get( iOppositePathIndex );
                LossyLinkDebug.print( "O Src:" + pathDataToo.getSrcHost() + " Dest:" + pathDataToo.getDestHost() );
                for( int j = 0; j < pathDataToo.linkIndexList.size(); j++ )
                {
                    LossyLinkDebug.print( " [" + pathDataToo.linkIndexList.get(j) + "]");
                }
                LossyLinkDebug.println("-------");
            }
//end debug

            if( iOppositePathIndex < i )
            {
                newPathList.add( pathData );
            }
        }
        pathList = newPathList;
        return 1;
    }
*/
    public int printPathInfo()
    {
      return iPathListCount;
    }
    public int printPathInfoOld()
    {
	int j = 0;
	int iAvgLinkCountPerPath = 0;
	int iMedian = 0;
	int iTotalLinkCount = 0;
	LossyLinkPathData pathData;

	int iPathListLen = iPathListCount;
	for( j = 0; j < iPathListLen; j++ )
	    {
		pathData = (LossyLinkPathData)pathList[j];
		iTotalLinkCount += pathData.linkIndexList.length;
		//LossyLinkDebug.println( "pathData.getCount() : " + pathData.getLinkCount() + " totalLinkCount " + iTotalLinkCount );
	    }

	if( iPathListLen != 0 )
	    {
		iAvgLinkCountPerPath = iTotalLinkCount / iPathListLen;
		iPathListLen = iPathListCount;
/*                if( LossyLinkDebug.isDebug() == true )
                    {
                        for( int x = 0; x < pathList.size(); x++ )
                        {
                            System.out.println("pathData[" + x + "] : [" +
                                               ( (LossyLinkPathData) pathList.get(x)).
                                               getSrcHost() + "] [" +
                                               ( (LossyLinkPathData) pathList.get(x)).
                                               getDestHost() + "] [" +
                                               ( (LossyLinkPathData) pathList.get(x)).
                                               getLinkCount());
                        }
                    }
*/
		LossyLinkSort.sortVectorByData( pathList );
//                LossyLinkDebug.println("After sort by link count" );

/*		if( LossyLinkDebug.isDebug() == true )
		    {
			for( int x = 0; x < pathList.size(); x++ )
		        {
			    System.out.println("pathData[" + x + "] : [" +
					       ( (LossyLinkPathData) pathList.get(x)).
					       getSrcHost() + "] [" +
					       ( (LossyLinkPathData) pathList.get(x)).
					       getDestHost() + "] [" +
					       ( (LossyLinkPathData) pathList.get(x)).
					       getLinkCount());
			}
		    }
*/		iMedian = ((LossyLinkPathData)pathList[( iPathListCount - 1 ) / 2] ).linkIndexList.length;
	    }//end if

	System.out.println( "\nTotal path count : " + iPathListLen );
        System.out.println( "Average link count per path : " + iAvgLinkCountPerPath );
	System.out.println( "Median of link count per path : " + iMedian );


	return iPathListLen;
    }


    public int getTotalPathCount()
    {
	return iPathListCount;
    }


    public void GenerateBvector( LossyLinkData data, boolean bLossProcessModel )
    {
    	//************** add by Jingo ************
	iLinkListCount = data.link.count();
	L = new double[iLinkListCount];
	if( bLossProcessModel == false )
	    {
                System.out.print("\t\tBernoulli Loss Model applied.");
		GenerateBernoulliBvector( data );
	    }
	else
	    {
                System.out.print("\t\tGilbert Loss Model applied.");
		GenerateGilbertBvector( data );
	    }
    }

    private void GenerateBernoulliBvector( LossyLinkData data )
    {
        LossyLinkPathData pathData;
        int iPathListLen = iPathListCount;
        int iPacketCount = 10000;
        int iPacketLossCount = 0;//packet loss count of a path
        B = new double[iPathListLen];

	//************** added by Jingo ************
	int loss[][] = new int[iLinkListCount][2];
	for(int i=0; i<iLinkListCount; i++) {
		loss[i][0] = loss[i][1] = 0;
	}

	 for( int i = 0; i < iPathListLen; i++ )
        {
            iPacketLossCount = 0;
            pathData = (LossyLinkPathData)pathList[i];
            int iLinkCountInAPath = pathData.linkIndexList.length;

            for( int j = 0; j < iPacketCount; j++ )
            {
                for( int k = 0; k < iLinkCountInAPath; k++)
                {
                    int iLinkIndex = pathData.linkIndexList[k];
                    double d = Math.random();
                    if ( d <= data.link.getLossRate(iLinkIndex) )
                    {
                        iPacketLossCount++;
			   loss[iLinkIndex][0]++;	//************** added by Jingo ************
			   loss[iLinkIndex][1]++;	//************** added by Jingo ************
                        break;
                    }
			else
				loss[iLinkIndex][1]++;	//************** added by Jingo ************
                }
            }

            if( iLinkCountInAPath == 0 )
            {
                System.err.println( "WARNING 00100 : GenerateBvector() Unrechable path : " + i );
                B[i] = -1.0; //unrechable path.
                System.exit( 0 );
            }
            else
            {
                //B matrix contains 'successful packet transmit rate' of each path.
                B[i] = 1.0 - ( (double)iPacketLossCount / (double)iPacketCount );
            }
        }

	 //************** added by Jingo ************
	for(int i=0; i<iLinkListCount; i++) {
		L[data.link.getLinkData(i)] = data.link.getLossRate(i);
	/*	if(loss[i][1] != 0)
			L[i] = (double) loss[i][0]/ loss[i][1];
		else
			L[i] = 0;
	
		int l = data.link.getLinkData(i);
		if(loss[l][1] != 0)
			L[l] = (double) loss[i][0]/ loss[i][1];
		else
			L[l] = 0;
	*/
	}
    }


    private void GenerateGilbertBvector( LossyLinkData data )
    {
        LossyLinkPathData pathData;
        int iPathListLen = iPathListCount;
        int iStagePacketCount = 1;
        int iPacketCount = 10000;
        int iPacketLossCount = 0;//packet loss count of a path
        int iStageCount = iPacketCount / iStagePacketCount;
        boolean bState[][] = new boolean[data.link.count()][iStageCount];
        B = new double[iPathListLen];
        double dProbToRemainGood = -1;
        double dProbToRemainBad = 0.35;

        //p : pathIndex
        //l : linkIndex
        //s : stageIndex
		System.out.println("Path number is " + iPathListLen);
		
        for (int l = 0; l < data.link.count(); l++)
        {
          double dInitProb = Math.random();
          double dLinkLossRate = data.link.getLossRate(l);
          if( dInitProb >= dLinkLossRate )
            bState[l][0] = true;
          else
            bState[l][0] = false;

          dProbToRemainGood = ( dLinkLossRate * ( 1-dProbToRemainBad ) ) / ( 1 - dLinkLossRate );
          for( int s = 1; s < iStageCount; s++ )
          {
            double dProb = Math.random();
            if( bState[l][s-1] == true )
            {
              if( dProb >= dProbToRemainGood )
                bState[l][s] = true;
              else
                bState[l][s] = false;
            }
            else
            {
              if( dProb < dProbToRemainBad )
                bState[l][s] = false;
              else
                bState[l][s] = true;
            }
          }// for stage
        }// for link

        for( int i = 0; i < iPathListLen; i++ )//for each path
        {
          iPacketLossCount = 0;
          pathData = (LossyLinkPathData)pathList[i];
          int iLinkCountInAPath = pathData.linkIndexList.length;
          for( int s = 0; s < iStageCount; s++)//for each stages
          {
            for( int l = 0; l < iLinkCountInAPath; l++ )//for each link in the path
            {
              int iLinkIndex = pathData.linkIndexList[l];
              if ( bState[iLinkIndex][s] == false )
              {
                iPacketLossCount++;
                break;
              }
            }
          }

          if( iLinkCountInAPath == 0 )
          {
            System.err.println( "WARNING 00100 : GenerateBvector() Unrechable path : " + i );
            B[i] = -1.0; //unrechable path.
            System.exit( 0 );
          }
          else
          {
            //B matrix contains 'successful packet transmit rate' of each path.
            B[i] = 1.0 - ( (double)(iPacketLossCount * iStagePacketCount) / (double)iPacketCount );
          }
        }

	 //************** add by Jingo ************
	 for(int i=0; i<iLinkListCount; i++) {
	 	double dLostNum = 0;
	 	for(int j=0; j<iStageCount; j++) {
			if(bState[i][j] == false)
				dLostNum++;
	 	}
	//	L[i] = dLostNum/iStageCount;
		if(data.link.getLinkData(i) < 0 || data.link.getLinkData(i) >= iLinkListCount)
			System.out.println("Bad i: " + i + ", bad id: %d" + iLinkListCount);
		L[data.link.getLinkData(i)] = dLostNum/iStageCount;
	 }
      }


    public void saveCvector( String strFileName, LossyLinkLink link )
    {
        if( strFileName == null )
        {
            Calendar calendar = Calendar.getInstance();
            strFileName = "LossyLink_C" + "_"
                                      + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                      + calendar.get( Calendar.MONTH ) + "-"
                                      + calendar.get( Calendar.YEAR ) + "_"
                                      + calendar.get( Calendar.HOUR ) + "-"
                                      + calendar.get( Calendar.MINUTE )
                                      + ".out";
        }

        int iRowCount =  iPathListCount;
        try
        {
            FileWriter output = new FileWriter( strFileName );
            output.write( Integer.toString( iRowCount ) );
            output.write( '\n' );
            LossyLinkPathData pathData;
            for( int i = 0; i < iRowCount; ++i )
            {
              pathData = (LossyLinkPathData)pathList[i];
              double dLinkLossRateList[] = new double[pathData.linkIndexList.length];
              dLinkLossRateList[0] = link.getLossRate( pathData.linkIndexList[0] );
              for( int j = 0; j < pathData.linkIndexList.length - 1; j++ )
              {
                dLinkLossRateList[j+1] = link.getLossRate( pathData.linkIndexList[j+1] );
              }

              double pathLossRate = 1;
              for( int k = 0; k < dLinkLossRateList.length; k++ )
              {
                pathLossRate = pathLossRate * ( 1 - dLinkLossRateList[k] );
              }
              //pathLossRate = 1-pathLossRate;

              output.write( Double.toString(pathLossRate) );
              output.write( '\n' );
            }
            output.close();
        }
        catch (IOException e)
        {
            System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
            System.exit(1);
        }
    }


    public void saveBvector( String strFileName )
    {
        if( strFileName == null )
        {
            Calendar calendar = Calendar.getInstance();
            strFileName = "LossyLink_B" + "_"
                                      + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                      + calendar.get( Calendar.MONTH ) + "-"
                                      + calendar.get( Calendar.YEAR ) + "_"
                                      + calendar.get( Calendar.HOUR ) + "-"
                                      + calendar.get( Calendar.MINUTE )
                                      + ".out";

            //strFileName = "LossyLink.out";
        }

        int iColCount = iPathListCount;
        try
        {
            FileWriter output = new FileWriter( strFileName );
            output.write( Integer.toString( iColCount ) );
            output.write( '\n' );
            for( int i = 0; i < iColCount; ++i )
            {
                output.write( Double.toString(B[i]) );
                output.write( '\n' );
            }
            output.close();
        }
        catch (IOException e)
        {
            System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
            System.exit(1);
        }
    }

    //************** add by Jingo ************
    public void saveLvector( String strFileName )
    {
        if( strFileName == null )
        {
            Calendar calendar = Calendar.getInstance();
            strFileName = "LossyLink_L" + "_"
                                      + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                      + calendar.get( Calendar.MONTH ) + "-"
                                      + calendar.get( Calendar.YEAR ) + "_"
                                      + calendar.get( Calendar.HOUR ) + "-"
                                      + calendar.get( Calendar.MINUTE )
                                      + ".out";
        }

        int iColCount = iLinkListCount;
        try
        {
            FileWriter output = new FileWriter( strFileName );
            output.write( Integer.toString( iColCount ) );
            output.write( '\n' );
            for( int i = 0; i < iColCount; ++i )
            {
                output.write( Double.toString(L[i]) );
                output.write( '\n' );
            }
            output.close();
        }
        catch (IOException e)
        {
            System.err.println( "LossyLinkPathInfo : File for L vectors is not written properely\n" + e.toString());
            System.exit(1);
        }
    }


    public void testLinkCoverage( LossyLinkData data )
    {
        int iLinkIndex = -1;
        System.out.println( "Test Link Coverage ----------------------------------------" );

        //verify
        for( int i = 0;  i < data.link.count() ; ++i )
        {
            if( data.link.getCoverage( i ) == false )
            {
                System.out.println( "TestLinkCoverage : WARNING : LinkIndex[" + i + "] not covered" );
            }
        }
        System.out.println( "Test Link Coverage Done" );
    }

    public void checkLinkCoverage( LossyLinkData data )
    {
        int iLinkIndex = -1;

        //clear
        for( int i = 0; i < data.link.count(); ++i )
        {
            data.link.setCoverage( i, false );
        }

        //mark
        for( int i = 0; i < iPathListCount; ++i )
        {
            LossyLinkPathData pathData = (LossyLinkPathData)pathList[i];
            int iLinkCountInAPath = pathData.linkIndexList.length;
            for (int j = 0; j < iLinkCountInAPath; ++j)
            {
                data.link.setCoverage( pathData.linkIndexList[j], true );
            }
        }

        //verify
        if( LossyLinkDebug.isDebug() == true )
        {
            for( int i = 0;  i < data.link.count() ; ++i )
            {
                if( data.link.getCoverage( i ) == false )
                {
                    System.out.println( "CheckLinkCoverage : LinkIndex[" + i + "] not covered" );
                }
            }
            System.out.println( "CheckLinkCoverage : Done" );
        }
    }

    public void reindex( LossyLinkData data )
    {
        int iLinkIndex = 0;
        for( int i = 0; i < iPathListCount; ++ i )
        {
            LossyLinkPathData pathData = (LossyLinkPathData)pathList[i];
            int iLinkCountInAPath = pathData.linkIndexList.length;

//            pathData.setSrcHost(  data.iNodeReindexTable[ pathData.getSrcHost() ] );
//            pathData.setDestHost( data.iNodeReindexTable[ pathData.getDestHost() ] );

            for (int j = 0; j < iLinkCountInAPath; ++j)
            {
                iLinkIndex = pathData.linkIndexList[j];
                pathData.linkIndexList[j] = data.iLinkReindexTable[iLinkIndex];

                if( data.iLinkReindexTable[iLinkIndex] == -1 )
                {
                    System.out.println( "ERROR 00075 iLinkIndex: " + iLinkIndex );
                }
/*
                int k = 0;
                for( k = 0; k < data.iLinkReindexTableCount; ++k )
                {
                    if( data.iLinkReindexTable[k] == iLinkIndex )
                    {
                        pathData.linkIndexList.set( j, new Integer(k) );
                        break;
                    }
                }
                if( k == data.iLinkReindexTableCount )
                {
                    System.out.println("ERROR : 00070 iLinkIndex : " + iLinkIndex );
                }
*/
            }
        }
    }

    public void showLink(  )
    {
        if( LossyLinkDebug.isDebug() == false )
        {
            return;
        }
        int iLinkIndex = -1;
        LossyLinkDebug.println("PathInfo ShowLink -------------------------------" );
        for( int i = 0; i < iPathListCount; ++ i )
        {
            LossyLinkPathData pathData = (LossyLinkPathData)pathList[i];
            int iLinkCountInAPath = pathData.linkIndexList.length;
            LossyLinkDebug.print("Path[" + i + "] : ");
//            LossyLinkDebug.print("src : " + pathData.getSrcHost() );
//            LossyLinkDebug.println("\tdest : " + pathData.getDestHost() + " " );
            for (int j = 0; j < iLinkCountInAPath; ++j)
            {
                iLinkIndex = pathData.linkIndexList[j];
                LossyLinkDebug.print( "[" + iLinkIndex + "] " );
            }
            LossyLinkDebug.println("");
        }
    }

    public void showLink2( LossyLinkData data )
    {
        int iLinkIndex = -1;
        System.out.println("PathInfo ShowLink -------------------------------" );
        for( int i = 0; i < iPathListCount; ++ i )
        {
            LossyLinkPathData pathData = (LossyLinkPathData)pathList[i];
            int iLinkCountInAPath = pathData.linkIndexList.length;
            LossyLinkDebug.print("Path[" + i + "] : ");
//            LossyLinkDebug.print("src : " + pathData.getSrcHost() );
//            LossyLinkDebug.println("\tdest : " + pathData.getDestHost() + " " );
            double dLinkWeight = 0;
            for (int j = 0; j < iLinkCountInAPath; ++j)
            {
                iLinkIndex = pathData.linkIndexList[j];
                LossyLinkDebug.print( "[" + iLinkIndex + "/" + data.link.getLinkData(iLinkIndex) + "] " );
                dLinkWeight += data.link.getWeight( iLinkIndex );
            }
            LossyLinkDebug.println("Weight : " + dLinkWeight );
            LossyLinkDebug.println("");
        }
    }
/*
    public void removeLink( int iRemovableLink )
    {
      int iLinkIndex = -1;

      for( int i = 0; i < pathList.size(); ++i )
      {
        LossyLinkPathData pathData = (LossyLinkPathData)pathList.get( i );
        int iLinkCountInAPath = pathData.linkIndexList.length;
        for( int j = 0; j < iLinkCountInAPath; ++j )
        {
          iLinkIndex = pathData.linkIndexList[j];
          if( iLinkIndex == iRemovableLink )
          {
            pathData.linkIndexList.remove( j );
            break;//Because there's no cycle in path, the possibility of occuring a link in a path is 1.
          }
        }
      }
    }
*/
/*
    public void reduceLink( int iReducedLink[], int iNewLink )
    {
        showLink();
        int iLinkIndex[] = new int[2];
        for( int i = 0; i < pathList.size(); ++ i )
        {
            LossyLinkPathData pathData = (LossyLinkPathData)pathList.get( i );
            int iLinkCountInAPath = pathData.linkIndexList.size();
            for (int j = 0; j < iLinkCountInAPath-1; ++j)
            {
                iLinkIndex[0] = ((Integer)pathData.linkIndexList.get( j )).intValue();
                if( iLinkIndex[0] == iReducedLink[0] )
                {
                    iLinkIndex[1] = ((Integer)pathData.linkIndexList.get( j + 1 )).intValue();
                    if( iLinkIndex[1] == iReducedLink[1] )
                    {
                        pathData.linkIndexList.set( j, new Integer( iNewLink ));
                        pathData.linkIndexList.remove( j+1 );
                    }
                    else
                    {
                        System.out.println( "WARNING 00071" );
                    }
                }
                else if( iLinkIndex[0] == iReducedLink[1] )
                {
                    iLinkIndex[1] = ((Integer)pathData.linkIndexList.get( j + 1 )).intValue();
                    if( iLinkIndex[1] == iReducedLink[0] )
                    {
                        pathData.linkIndexList.set( j, new Integer( iNewLink ));
                        pathData.linkIndexList.remove( j+1 );
                    }
                    else
                    {
                        System.out.println("WARNING 00072" );
                    }
                }
            }
        }
    }
*/
/*    //G matrix : N*N-1 by L matrix, where N is pathCount and L is linkCount.
    public void updateGmatrix( int iLinkCount )
    {
      int iRowCount = pathList.size();//N * ( N - 1 ), while N is the number of end host
      int iColCount = iLinkCount;//total count of links in topology. iTotalLinkCount == MAX( iLinkIndex )
      iGmatrix = new byte[iRowCount][iColCount];
      int iNonZeroInRowCount = 0;
      LossyLinkPathData pathData;

      for( int i = 0; i < iRowCount; ++i )
      {
        pathData = (LossyLinkPathData)pathList.get( i );
        iNonZeroInRowCount = pathData.linkIndexList.size();
        for( int j = 0; j < iNonZeroInRowCount; ++j )
        {
          iGmatrix[i][((Integer)pathData.linkIndexList.get(j)).intValue()] = 1;
        }
      }
    }
*/



    public void readGmatrix( String strFileName, LossyLinkLink link, int iStat[] )
    {
      String strFileLine;
      String strTmp;
      int iRowCount = 0;
      int iColCount = 0;
      int iNonZeroCount = 0;
      int iNonZeroInAPath = 0;
      int iPathIndex = 0;
      int iLinkData2IndexTable[];
      int iLinkIndex = 0;

      try
      {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strFileName))));

        iRowCount = Integer.parseInt( bufferedReader.readLine().trim() );
        iColCount = Integer.parseInt( bufferedReader.readLine().trim() );
        //iNonZeroCount = Integer.parseInt( bufferedReader.readLine().trim() );
        iLinkDataMax = iColCount;

        iStat[0] = iColCount;
        iLinkData2IndexTable = new int[iColCount];
        pathList = new LossyLinkPathData[iRowCount];
        for( int i = 0; i < iLinkData2IndexTable.length; i++)
        {
          iLinkData2IndexTable[i] = -1;
        }

	int iLineCount = 0;
        for( iLineCount = 0; (strFileLine = bufferedReader.readLine()) != null; iLineCount++ )
        {
          StringTokenizer st = new StringTokenizer( strFileLine, "\t " );
          iNonZeroInAPath = Integer.parseInt( st.nextToken() );

          iPathIndex = newLinkInPath( iNonZeroInAPath );

          for( int i = 0; i < iNonZeroInAPath; i++ )
          {
            int iLinkData = Integer.parseInt(st.nextToken());

            if( iLinkData2IndexTable[iLinkData] == -1 )
            {
              link.set( iLinkIndex, iLinkData, -1, -1, true );
              iLinkData2IndexTable[iLinkData] = iLinkIndex;
              iLinkIndex++;
            }
            addLinkInPath( iPathIndex, iLinkData2IndexTable[iLinkData] );
          }
          if(pathList[iPathIndex].linkIndexList.length == 0)
	   		System.out.println("Warning, iPathIndex:" + iPathIndex);
        }
        if( iLineCount != iRowCount )
        {
          System.out.println("LLPI ERROR 00105 : Row count doesn't match number of paths in " + strFileName );
          System.exit( 0 );
        }
        bufferedReader.close();
        iStat[1] = iLinkIndex;
      }
      catch( IOException e )
      {
        System.err.println("ERROR LLPI 01000 : File format error\n" + e.toString() );
        System.exit(1);
      }
    }

    //G matrix : N*N-1 by L matrix, where N is pathCount and L is linkCount.
    public void saveGmatrix( String strFileName, LossyLinkLink link )
    {
	LossyLinkPathData pathData;
	int iNonZeroCount = 0;
	int iNonZeroInRowCount = 0;
	int iRowCount = iPathListCount;//N * ( N - 1 ), while N is the number of end host
	int iColCount = iLinkDataMax;//link.count();//total count of links in topology. iTotalLinkCount == MAX( iLinkIndex )
//        iGmatrix = new int[iRowCount][iColCount];
        int iTotalPathOccurance = 0;

	if( strFileName == null )
	{
	    Calendar calendar = Calendar.getInstance();
	    strFileName = "LossyLink_G" + "_"
				      + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
				      + calendar.get( Calendar.MONTH ) + "-"
				      + calendar.get( Calendar.YEAR ) + "_"
				      + calendar.get( Calendar.HOUR ) + "-"
				      + calendar.get( Calendar.MINUTE )
				      + ".out";

	    //strFileName = "LossyLink.out";
	}

	/*
	for( int i = 0; i < iRowCount; ++i )
	{
	    iNonZeroCount += ((LossyLinkPathData)pathList[i]).linkIndexList.length;
	}
	*/

	try
	{
	    FileWriter output = new FileWriter( strFileName );
	    output.write( Integer.toString( iRowCount ) );
	    output.write( '\n' );
	    output.write( Integer.toString( iColCount ) );
	    output.write( '\n' );
	    //output.write( Integer.toString(iNonZeroCount) );
	    //output.write( '\n' );
	    for( int i = 0; i < iRowCount; ++i )
	    {
		pathData = (LossyLinkPathData)pathList[i];
		iNonZeroInRowCount = pathData.linkIndexList.length;
		output.write( Integer.toString( iNonZeroInRowCount ) );
		output.write( ' ' );

                //LossyLinkDebug.println("G matrix srcNode : " + pathData.getSrcHost() + " destNode : " + pathData.getDestHost());

		for( int j = 0; j < iNonZeroInRowCount; ++j )
		{
                    output.write( String.valueOf( link.getLinkData(pathData.linkIndexList[j]) ) );
//                    iGmatrix[i][link.getLinkData( pathData.linkIndexList[j] )] = 1;
                    output.write( ' ' );
                    LossyLinkDebug.print(" [" + link.getLinkData(pathData.linkIndexList[j]) + "]");
                    iTotalPathOccurance++;
		}
                LossyLinkDebug.println("");
		output.write( '\n' );
	    }
	    output.close();

            LossyLinkDebug.println( "Average path count per link : " + iTotalPathOccurance / link.count() );


/*
            for( int i = 0; i < iRowCount; ++i )
            {
                for( int j = 0; j < iColCount; ++j )
                    {
                        if( iGmatrix[i][j] == 1 )
                        {
                            System.out.print( "X" );
                        }
                        else
                        {
                            System.out.print( "." );
                        }
                    }
                    System.out.println("");
            }
*/


	}
	catch (IOException e)
	{
	    System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
	    System.exit(1);
	}
    }



    public void readIvector( String strFileName )
    {
      LossyLinkPathData newPathList[];
      double newB[];
      int iNewPathListCount = 0;


      String strFileLine;
      String strTmp;

      int iRowCount = 0;
      int iColCount = 0;
      int iLineCount = 0;

      try
      {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strFileName))));
        strFileLine = bufferedReader.readLine().trim();
        iRowCount = Integer.parseInt( strFileLine );
        strFileLine = bufferedReader.readLine().trim();
        newPathList = new LossyLinkPathData[iRowCount];
        newB = new double[iRowCount];
        iColCount = Integer.parseInt( strFileLine );
        while( iLineCount <= iRowCount && (strFileLine = bufferedReader.readLine()) != null )
        {
          int iP1 = 0;
          int iP2 = 0;
          int iMonitoredPathIndex = Integer.parseInt( strFileLine.trim() );
          newPathList[iNewPathListCount] = pathList[iMonitoredPathIndex];
          newB[iNewPathListCount] = B[iMonitoredPathIndex];
          iNewPathListCount++;

        }
        pathList = newPathList;
        B = newB;
        iPathListCount = iNewPathListCount;

        System.out.println( "pathList size" + iPathListCount + "\tiRowCount : " + iRowCount );

        bufferedReader.close();
      }
      catch( IOException e )
      {
        System.err.println("LossyLinkGbar : File format error\n" + e.toString() );
        System.exit(1);
      }
    }

}



class LossyLinkPathData
{
    public int iIndex;                  //index of path data itself
    public int linkIndexList[];

    public LossyLinkPathData( int iLinkIndexListCount )
    {
        iIndex = 0;
	linkIndexList = new int[iLinkIndexListCount];
    }

    public void addLinkIndex( int iLinkIndex )
    {
      linkIndexList[iIndex] = iLinkIndex;
      iIndex++;
    }
}
