/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


import java.io.*;
import java.util.*;


public class LossyLinkPathLossRate {
      static LossRateData truePath;
      static LossRateData inferredPath;

      static int iTrueLossyPathCount;
      static int iInferredLossyPathCount;

      static double dBadRealPathLossRateMin;
      static double dBadInferredPathLossRateMin;

      static String strBvectorFile[];
      static String strBhatVectorFile[];

      static double dFPpath[];
      static int iFPpathCount;

    //for Relative error
      static double dLossProb[][];
      static int iTrialCount            = 0;
      static int iLossProbCount         = 0;

      static double dEpsilon;

      static double dCDF[][];      //dCDF shows ratio of real_/inferred
      static int iMaxPercentage;
      static String strRelativeCDFfile;
    
    //for Absolute error
      static double dDiff[][];
      static double dAbsoluteCDF[][];
      static String strAbsoluteCDFfile;
          
      public LossyLinkPathLossRate()
      {
        init();
      }

      static private void init()
      {
        iTrueLossyPathCount             = 0;
        iInferredLossyPathCount         = 0;
        dBadRealPathLossRateMin         = 0.05;
        dBadInferredPathLossRateMin     = 0.05;
        dEpsilon                        = 0.001;
        iFPpathCount                    = 0;
	iMaxPercentage                  = 99;    //Maximum percentage CDF graph to plot
      }


      public static void main(String[] args)
      {
	  LossyLinkDebug.setDebug(false );
          parseInput( args );

          //1. Evaluate B vector file
          LossyLinkDebug.println("    Specification for B vector" );
          LossyLinkDebug.println("\n1. Evaluate ["+strBvectorFile+"] ["+strBhatVectorFile+"]" );

          dLossProb = new double[iTrialCount][];
	  dDiff     = new double[iTrialCount][];
          for( int i = 0; i < iTrialCount; i++ )
          {
            init();

            open( strBvectorFile[i], strBhatVectorFile[i] );
	    compare();
            identifyLossyPath();
            calculateLossProb(i);
	    calculateDiff(i);
          }
          calculateRelativeErrorCDF();
	  calculateAbsoluteErrorCDF();
          saveRelativeCDF( strRelativeCDFfile );
          saveAbsoluteCDF( strAbsoluteCDFfile );
	  System.out.println("Relative CDF file : " +strRelativeCDFfile );
	  System.out.println("Absolute CDF file : " +strAbsoluteCDFfile );
	  
      }

      public static void calculateRelativeErrorCDF( )
      {
        double dAvgLossProb[];
        dAvgLossProb = new double[inferredPath.iCount];

        //Average error rate of each trial
        for( int i = 0; i < inferredPath.iCount; i++ )
        {
          for( int j = 0; j < iTrialCount; j++ )
          {
            dAvgLossProb[i] = dAvgLossProb[i] + dLossProb[j][i];
          }
          dAvgLossProb[i] = dAvgLossProb[i] / (double)iTrialCount;
        }
        Arrays.sort( dAvgLossProb );

       
        dCDF = new double[iMaxPercentage][2];
	int iTotalErrCount = dAvgLossProb.length;
	for( int i = 0; i < iMaxPercentage; i++ )
	{
   	    dCDF[i][0] = dAvgLossProb[(int)Math.round((double)iTotalErrCount*(double)(i+1)/100.0) - 1];       // X axis : error (loss probability)
	    dCDF[i][1] = ((double)(i+1));///100.0;                     // Y axis : cumulative number of errors
	}
	return;
      }

      public static void calculateAbsoluteErrorCDF()
      {
        double dAvgDiff[];
        dAvgDiff = new double[inferredPath.iCount];

        //Average error rate of each trial
        for( int i = 0; i < inferredPath.iCount; i++ )
        {
          for( int j = 0; j < iTrialCount; j++ )
          {
            dAvgDiff[i] = dAvgDiff[i] + dDiff[j][i];
          }
          dAvgDiff[i] = dAvgDiff[i] / (double)iTrialCount;
        }
        Arrays.sort( dAvgDiff );

	/*
	for( int i = 0; i < dAvgDiff.length; i++ )
	    {
		System.out.println("dAvgDiff["+i+"] : "+dAvgDiff[i] );
	    }
	*/

        dAbsoluteCDF = new double[iMaxPercentage][2];
	int iTotalErrCount = dAvgDiff.length;
	for( int i = 0; i < iMaxPercentage; i++ )
	{
   	    dAbsoluteCDF[i][0] = dAvgDiff[(int)Math.round((double)iTotalErrCount*(double)(i+1)/100.0) - 1];           // X axis : absolute error
	    dAbsoluteCDF[i][1] = ((double)(i+1));///100.0;                     // Y axis : cumulative number of errors
	}
	return;
      }

      public static int open( String strTrueFileName, String strInferredFileName )
      {
          int iArrSize = 0;//Total link count in the topology.
          int iComputablePathCount = 0;//Computable link count, iComputableLinkCount <= iArrSize

          if( strTrueFileName == null && strInferredFileName == null )
          {
              System.out.println( "ERROR 00001" );
              return -1;
          }

          try
          {
              BufferedReader trueLossRateReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strTrueFileName))));

              String strTmp;
              if( ( strTmp = trueLossRateReader.readLine() ) != null )
              {
                  iArrSize = Integer.parseInt( strTmp );
                  truePath = new LossRateData( iArrSize );
              }
              else
              {
                  System.err.println("ERROR LLLR 00400 : Can not read input file ["+strTrueFileName+"]");
                  System.exit(0);
              }

              int i = 0;
              for( i = 0; i < truePath.iCount && ( ( strTmp = trueLossRateReader.readLine() ) != null ); ++i )
              {
		  truePath.dLossRate[i] = 1 - Double.parseDouble( strTmp );//Han-hee's convention
              }
              trueLossRateReader.close();
          }
          catch (IOException e)
          {
              System.err.println( "LossyLinkPathLossRate : File not opened properely\n" + e.toString());
              System.exit(1);
          }

          // ----------------------------------------------

          try
          {
              BufferedReader inferredLossRateReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strInferredFileName))));

              String strTmp;
              //first line in X file indicates initial link count
              if( ( strTmp = inferredLossRateReader.readLine() ) != null )
              {
                  inferredPath = new LossRateData( iArrSize );
              }
              else
              {
                  System.err.println("ERROR LLLR 00400 : Can not read input file ["+strTrueFileName+"]");
                  System.exit(0);
              }

              for( int i = 0; i < inferredPath.iCount && ( ( strTmp = inferredLossRateReader.readLine() ) != null ); ++i )
              {
                  inferredPath.dLossRate[i] = 1 - Double.parseDouble( strTmp );//Han-hee's convention
              }

              inferredLossRateReader.close();
          }
          catch (IOException e)
          {
              System.err.println( "LossyLinkLossRate : File not opened properely\n" + e.toString());
              System.exit(1);
          }

	  dFPpath = new double[inferredPath.iCount];

          return truePath.iCount;
      }

      //calculation for relative error CDF
      public static void calculateLossProb( int iTrialIndex )
      {
        dLossProb[iTrialIndex] = new double[inferredPath.iCount];

        for( int i = 0; i < inferredPath.iCount; i++ )
        {
          double dPE = Math.max( truePath.dLossRate[i], dEpsilon );
          double dQE = Math.max( inferredPath.dLossRate[i], dEpsilon );
          dLossProb[iTrialIndex][i] = Math.max( dPE/dQE, dQE/dPE );
          iLossProbCount++;
        }

        Arrays.sort( dLossProb[iTrialIndex] );
      }
    
      //calculation for absolute error CDF
      public static void calculateDiff( int iTrialIndex )
      {
	  dDiff[iTrialIndex] = new double[inferredPath.iCount]; 
	  for( int i = 0; i < inferredPath.iCount; i++ )
	      {
		  dDiff[iTrialIndex][i] = Math.abs( truePath.dLossRate[i] - inferredPath.dLossRate[i] );
	      }
	  Arrays.sort( dDiff[iTrialIndex] );
      }



      public static void compare()
      {
	  double dTol = 0.01;
          LossyLinkDebug.println("\t\n\n\nCompare b and b_hat vectors---------------------------------------------------------");

          if( truePath.iCount != inferredPath.iCount )
          {
              System.out.println("\tERROR LLPLR 10000 : Dimension mismatch between B and B hat vector.");
              System.out.println("\tMaybe you forgot to process in MATLAB?" );
              return;
          }


	  LossyLinkDebug.println( "Note : Only difference greater than " + dTol + " are shown " +
			      "\nIndex\tb vector(A)\tb hat vector(B)\tDifference(A-B)"+
			      "\n--------------------------------------------------------------------------------------------" );

	  int iDiffCount = 0;
          for( int i = 0; i < truePath.iCount; ++i )
          {
	      double dDiff = 0.0;
	      if( ( dDiff = Math.abs( truePath.dLossRate[i] - inferredPath.dLossRate[i] ) ) > dTol )
		  {
		    iDiffCount++;
		      LossyLinkDebug.println( i + "\t" + rounding( truePath.dLossRate[i], 3 ) + "\t\t" + rounding( inferredPath.dLossRate[i], 3 ) + "\t\t" + rounding( dDiff, 3 ));
		  }
	      if( inferredPath.dLossRate[i] > 1.5 || inferredPath.dLossRate[i] < -0.5 )
		  {
		      LossyLinkDebug.println( "Suspecious element : " + i + "\t" + rounding( truePath.dLossRate[i], 3 ) + "\t\t" + rounding( inferredPath.dLossRate[i], 3 ) + "\t\t" + rounding( dDiff, 3 ));
		      //System.exit(0);
		  }
          }
	  System.out.println( "[" + iDiffCount + "] differences found." );
      }

      public static int identifyLossyPath()
      {
          int iCoverage = 0;

          LossyLinkDebug.println("\t\n\nIdentify lossy path ---------------------------------------------------------");

          if( truePath.iCount != inferredPath.iCount )
          {
              System.out.println("\tERROR LLPLR 00057 : Dimension mismatch between B and B hat vector.");
              System.out.println("\tMaybe you forgot to process in MATLAB?" );
              return 0;
          }

          for( int i = 0; i < truePath.iCount; ++i )
          {
              if( truePath.dLossRate[i] >= dBadRealPathLossRateMin )
              {
                  truePath.iLossyFlag[i] = 1;
                  iTrueLossyPathCount++;
              }
              if( inferredPath.dLossRate[i] >= dBadInferredPathLossRateMin )
              {
                  inferredPath.iLossyFlag[i] = 1;
                  iInferredLossyPathCount++;
              }

              if( truePath.iLossyFlag[i] == 1
                  && inferredPath.iLossyFlag[i] == 1 )
              {
                  iCoverage++;
              }
              else if( truePath.iLossyFlag[i] == 1
                       && inferredPath.iLossyFlag[i] != 1 )
              {
                LossyLinkDebug.println("\tFalse negative lossy path[ " + i + 
				       " ] : inferred : " + rounding( inferredPath.dLossRate[i], 3 ) + 
				       " true : " + rounding( truePath.dLossRate[i], 3 ) );
		    //"\t\tdiff : " + rounding( ( inferredPath.dLossRate[i] - dBadInferredPathLossRateMin ), 3 ) + 
		    //" than BadInferredPathLossRateMin\n" );
              }
              else if( truePath.iLossyFlag[i] != 1
               && inferredPath.iLossyFlag[i] == 1 )
              {
                  LossyLinkDebug.println("\tFalse positive lossy path[ " + i + 
					 " ] : inferred : " + rounding( inferredPath.dLossRate[i], 3 ) + 
					 " true : " + rounding( truePath.dLossRate[i], 3 ) + "\n" );
		  dFPpath[ iFPpathCount ] = inferredPath.dLossRate[i];
		  iFPpathCount++;
              }

          }

	  //sort dFPpath.
	  Arrays.sort( dFPpath, 0, iFPpathCount );

	  //show sorted result.
          LossyLinkDebug.println("\n\nSorted false positives ----------------------------");
          for( int i = 0; i < iFPpathCount; i++ )
              {
                  LossyLinkDebug.println("["+(i+1)+"]" + " FP[" + rounding( dFPpath[i], 3 ) + "]");
              }
          LossyLinkDebug.println("-------------------------------------------------------");

          System.out.println("\n   Result of lossy path identification  -----------------------------------");
	  //          System.out.println("\t# of total true paths :  \t\t" + iTruePathCount );
          System.out.println("\t# of total inferred paths(rank) :  \t" + inferredPath.iCount + "/" + truePath.iCount  );
          System.out.println("\t# of true lossy paths :  \t\t" + iTrueLossyPathCount );
          System.out.println("\t# of inferred lossy paths :  \t\t" + iInferredLossyPathCount );
          System.out.println("\t# of overlap :  \t\t\t" + iCoverage + "\n\t\t(Between true lossy path and inferred lossy paths, " +
                             "\n\t\tnot including uncomputable lossy paths)" );

          if( iTrueLossyPathCount > 0 )
          {
              System.out.println("\tAccuracy excluding uncomputable lossy paths :  " + ( 100 * iCoverage / iTrueLossyPathCount ) + "%" );
          }
          if( iTrueLossyPathCount > 0 && iInferredLossyPathCount > 0 )
          {
              double dAccuracy  = 100 * ((double)iCoverage / iTrueLossyPathCount );
              System.out.println("\tAccuracy :  \t\t\t\t" + rounding( dAccuracy, 3 ) + "%" );
	      double dFalsePositiveRatio = 100*((double)( iInferredLossyPathCount - iCoverage )/iInferredLossyPathCount );
              System.out.println("\tFalse positive (ratio) : \t\t" + ( iInferredLossyPathCount - iCoverage ) + " : " + rounding( dFalsePositiveRatio, 3 )  + "%" );
          }


	  System.out.println("dBadRealPathLossRateMin : " + dBadRealPathLossRateMin + " dBadInferredPathLossRateMin : " + dBadInferredPathLossRateMin );
          return 1;
      }

      private static void showUsage()
      {
          System.err.println("\nUsage: \njava LossyLinkLossRate " +
                  "<T_vector_file_name> <X_vector_file_name> <New_X_vecotr_file_name>\n" +
                  "or java LossyLinkLossRate <Input_script_file>\n" +
                  "\ni.e. java LossyLinkLossRate ../BRITE/topology/ASBarabasi100U_T.out ../BRITE/topology/ASBarabasi100U_X.out ../BRITE/topology/ASBarabasi100U_newX.out" +
                  "\ni.e. java LossyLinkLossRate ASBarabasi100U.input" );
      }

      public static String rounding( double dNumber, int point )
      {
          String strNumber = Double.toString( dNumber );
          if( ( strNumber.indexOf( "E" ) != -1 )
             || ( strNumber.indexOf( "NaN" ) != -1 )
             || ( strNumber.indexOf( "Inf" ) != -1 ) )
          {
              return strNumber;
          }
          int iDelimeter = strNumber.lastIndexOf(".");
          int iOffset = iDelimeter + point + 1;
          if( iOffset > strNumber.length() )
          {
              iOffset = strNumber.length();
          }
          return strNumber.substring( 0, iOffset );
      }



      public static void parseInput( String args[] )
      {
          iTrialCount = args.length;
          strBvectorFile = new String[iTrialCount];
          strBhatVectorFile = new String[iTrialCount];

          for( int i = 0; i < iTrialCount; i++ )
          {
            if (args[i].indexOf(".input") != -1)
            {
              parseInputScriptFile(args[i], i );
            }
          }
      }

      public static void parseInputScriptFile( String strFileName, int iTrialCount )
      {
          String strLine;
          try
          {
              BufferedReader inputScriptReader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(strFileName))));

              for( int i = 0; ( strLine = inputScriptReader.readLine() ) != null; ++i )
              {
                  StringTokenizer st = new StringTokenizer( strLine, "\t\n\r= " );

                  //loop for every token
                  String strDefinition = null;
                  String strValue = null;
                  String strToken = null;
                  while( st.hasMoreTokens() )
                  {
                      strToken = st.nextToken();

                      //Ignore comments
                      if( strToken.startsWith( "//" ) == true )
                      {
                          break;
                      }

                      //Store script file fields into strDefinition and strValue
                      if( strDefinition == null )
                      {
                          strDefinition = strToken;
                          continue;
                      }
                      strValue = strToken;
                      if( strValue.length() == 0 )
                      {
                          System.err.println("ERROR LLLR 00121 : No value specified for " + strDefinition + " field" );
                          showUsage();
                          System.exit( 0 );
                      }
                      LossyLinkDebug.println("strDefinition : " + strDefinition );
                      LossyLinkDebug.println("strValue : " + strValue );

                      if( strDefinition.compareToIgnoreCase( "outputFileName" ) == 0 )
                      {
                          strBvectorFile[iTrialCount] = strValue + "_B.out";
                          strBhatVectorFile[iTrialCount] = strValue + "_Bhat.out";
                          strRelativeCDFfile = strValue + "_relative.cdf";
                          strAbsoluteCDFfile = strValue + "_absolute.cdf";
                          break;
                      }
                      else if( strDefinition.compareToIgnoreCase( "Debug" ) == 0 )
                      {
                          if( strValue.compareTo( "1" ) == 0 )
                          {
                              LossyLinkDebug.setDebug( true );
                          }
                          break;
                      }
                  }//end while
              }//end for
              inputScriptReader.close();
          }
          catch (IOException e)
          {
              System.err.println( "LossyLinkLossRate : File not opened properely\n" + e.toString());
              showUsage();
              System.exit(1);
          }
      }


      static public void saveRelativeCDF( String strFileName )
      {
          if( strFileName == null )
          {
              Calendar calendar = Calendar.getInstance();
              strFileName = "LossyLink_CDF" + "_"
                                        + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                        + calendar.get( Calendar.MONTH ) + "-"
                                        + calendar.get( Calendar.YEAR ) + "_"
                                        + calendar.get( Calendar.HOUR ) + "-"
                                        + calendar.get( Calendar.MINUTE )
                                        + ".out";
          }

          int iRowCount = dCDF.length;
          try
          {
              FileWriter output = new FileWriter( strFileName );
//              output.write( Integer.toString( iRowCount ) );
//              output.write( '\n' );
              for( int i = 0; i < iRowCount; ++i )
              {
                output.write( Double.toString( dCDF[i][0] ) );
                output.write( "\t" );
                output.write( Double.toString( dCDF[i][1] ) );
                output.write( '\n' );
		//for debug System.out.println("dCDF["+i+"] x:"+dCDF[i][0]+"\ty:"+dCDF[i][1]);
              }
              output.close();
          }
          catch (IOException e)
          {
              System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
              System.exit(1);
          }
      }

      static public void saveAbsoluteCDF( String strFileName )
      {
          if( strFileName == null )
          {
              Calendar calendar = Calendar.getInstance();
              strFileName = "LossyLink_AbsoluteCDF" + "_"
                                        + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                        + calendar.get( Calendar.MONTH ) + "-"
                                        + calendar.get( Calendar.YEAR ) + "_"
                                        + calendar.get( Calendar.HOUR ) + "-"
                                        + calendar.get( Calendar.MINUTE )
                                        + ".out";
          }

          int iRowCount = dAbsoluteCDF.length;
          try
          {
              FileWriter output = new FileWriter( strFileName );
//              output.write( Integer.toString( iRowCount ) );
//              output.write( '\n' );
              for( int i = 0; i < iRowCount; ++i )
              {
                output.write( Double.toString( dAbsoluteCDF[i][0] ) );
                output.write( "\t" );
                output.write( Double.toString( dAbsoluteCDF[i][1] ) );
                output.write( '\n' );
		//for debug System.out.println("dAbsoluteCDF["+i+"] x:"+dAbsoluteCDF[i][0]+"\ty:"+dAbsoluteCDF[i][1]);
              }
              output.close();
          }
          catch (IOException e)
          {
              System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
              System.exit(1);
          }
      }
}



class LossRateData
{
    public double dLossRate[];
    public int iLossyFlag[];
    public int iCount = 0;

    public LossRateData( int iLinkCount )
    {
        dLossRate = new double[ iLinkCount ];
        iLossyFlag = new int[ iLinkCount ];
        iCount = iLinkCount;
    }
}
