//// package LossyLink;

/**
 * <p>Title: LossyLinkSort</p>
 * <p>Description: The <CODE>LossyLinkSort</CODE> class is used to Sort arrays, 2 dimensional arrays and linked lists
 * using Quick Sort algorithm.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


// package LossyLink;



import java.io.*;
import java.util.*;


class LossyLinkSort
{
/*    public static int sortArray( int iArr[] )
    {
        return sortArray( iArr, 0, iArr.size()-1 );
    }
*/
    public static int sortArray( int iArr[], int lo0, int hi0 )// throws Exception
    {
        int lo = lo0;
        int hi = hi0;
        int mid;

        if( hi0 > lo0 )
            {
                mid = iArr[( lo0 + hi0 ) / 2];

                while( lo <= hi )
                    {
                        while( ( lo < hi0 )
                               && ( iArr[ lo ] < mid ))
                            ++lo;

                        while( ( hi > lo0 )
                               && ( iArr[ hi ] > mid ) )
                            --hi;

                        if( lo <= hi )
                            {
				int iTmp = iArr[ lo ];
				iArr[ lo ] = iArr[ hi ];
				iArr[ hi ] = iTmp;
                                ++lo;
                                --hi;
                            }
                    }
            }
        if( lo0 < hi )
            sortArray( iArr, lo0, hi );
        if( lo < hi0 )
            sortArray( iArr, lo, hi0 );

        return 1;
    }



/*
    public static int sort2dArray( int iArr[] )
    {
        return sort2dArray( iArr, 0, iArr.size()-1 );
    }
*/
    public static int sort2dArray( int iArr[][], int lo0, int hi0 )// throws Exception
    {
        int lo = lo0;
        int hi = hi0;
        int mid;

        if( hi0 > lo0 )
            {
                mid = iArr[( lo0 + hi0 ) / 2][0];

                while( lo <= hi )
                    {
                        while( ( lo < hi0 )
                               && ( iArr[ lo ][0] < mid ))
                            ++lo;

                        while( ( hi > lo0 )
                               && ( iArr[ hi ][0] > mid ) )
                            --hi;

                        if( lo <= hi )
                        {
			    int iTmp[] = new int[2];

			    iTmp[0] = iArr[lo][0];
			    iTmp[1] = iArr[lo][1];

			    iArr[lo][0] = iArr[hi][0];
			    iArr[lo][1] = iArr[hi][1];

			    iArr[hi][0] = iTmp[0];
			    iArr[hi][1] = iTmp[1];

			    ++lo;
			    --hi;
                        }
                      }
            }
        if( lo0 < hi )
            sort2dArray( iArr, lo0, hi );
        if( lo < hi0 )
            sort2dArray( iArr, lo, hi0 );

        return 1;
    }



    public static int sortListByData( LinkedList list )
    {
        return sortListByData( list, 0, list.size()-1 );
    }

    private static int sortListByData( LinkedList list, int lo0, int hi0 )// throws Exception
    {
        int lo = lo0;
        int hi = hi0;
        int mid;

        if( hi0 > lo0 )
            {
                mid = ((LossyLinkPathData)list.get( ( lo0 + hi0 ) / 2 ) ).linkIndexList.length;

                while( lo <= hi )
                    {
                        while( ( lo < hi0 )
                               && ( ((LossyLinkPathData)list.get( lo )).linkIndexList.length < mid ))
                            ++lo;

                        while( ( hi > lo0 )
                               && ( ((LossyLinkPathData)list.get( hi )).linkIndexList.length > mid ) )
                            --hi;

                        if( lo <= hi )
                            {
				Object tmpObject = list.get( lo );
				list.set( lo, list.get( hi ) );
				list.set( hi, tmpObject );
                                ++lo;
                                --hi;
                            }
                    }
            }
        if( lo0 < hi )
            sortListByData( list, lo0, hi );
        if( lo < hi0 )
            sortListByData( list, lo, hi0 );

        return 1;
    }

    public static int sortList( LinkedList list )
    {
        return sortList( list, 0, list.size()-1 );
    }

    private static int sortList( LinkedList list, int lo0, int hi0 )// throws Exception
    {
        int lo = lo0;
        int hi = hi0;
        int mid;

        if( hi0 > lo0 )
            {
                mid = ((Integer)list.get( ( lo0 + hi0 ) / 2 ) ).intValue();

                while( lo <= hi )
                    {
                        while( ( lo < hi0 )
                               && ( ((Integer)list.get( lo )).intValue() < mid ))
                            ++lo;

                        while( ( hi > lo0 )
                               && ( ((Integer)list.get( hi )).intValue() > mid ) )
                            --hi;

                        if( lo <= hi )
                            {
                                Object tmpObject = list.get( lo );
                                list.set( lo, list.get( hi ) );
                                list.set( hi, tmpObject );
                                ++lo;
                                --hi;
                            }
                    }
            }
        if( lo0 < hi )
            sortList( list, lo0, hi );
        if( lo < hi0 )
            sortList( list, lo, hi0 );

        return 1;
    }


    public static int sortVectorByData( LossyLinkPathData list[] )
    {
        return sortVectorByData( list, 0, list.length-1 );
    }

    private static int sortVectorByData( LossyLinkPathData list[], int lo0, int hi0 )// throws Exception
    {
        int lo = lo0;
        int hi = hi0;
        int mid;

        if( hi0 > lo0 )
            {
                mid = ((LossyLinkPathData)list[ ( lo0 + hi0 ) / 2] ).linkIndexList.length;

                while( lo <= hi )
                    {
                        while( ( lo < hi0 )
                               && ( ((LossyLinkPathData)list[lo]).linkIndexList.length < mid ))
                            ++lo;

                        while( ( hi > lo0 )
                               && ( ((LossyLinkPathData)list[hi]).linkIndexList.length > mid ) )
                            --hi;

                        if( lo <= hi )
                            {
                                Object tmpObject = list[lo];
                                list[lo] = list[hi];
                                list[hi] = (LossyLinkPathData)tmpObject;
                                ++lo;
                                --hi;
                            }
                    }
            }
        if( lo0 < hi )
            sortVectorByData( list, lo0, hi );
        if( lo < hi0 )
            sortVectorByData( list, lo, hi0 );

        return 1;
    }
}

