

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


// package LossyLink;


import java.io.*;
import java.util.*;
//package lossylink;

public class LossyLinkStaticModel
{
    public static double dGoodLinkRate = -1.0;

    public static double dGoodLinkLossRateMin = -1.0;
    public static double dGoodLinkLossRateMax = -1.0;
    public static double dBadLinkLossRateMin = -1.0;
    public static double dBadLinkLossRateMax = -1.0;

    private static double dGoodLinkLossRate = -1.0;
    private static double dBadLinkLossRate = -1.0;

    private static double dLinkLossRate[];
    private static int iLinkCount = 1000000;
    private static String strLinkLossRateFile = "LinkLossRate.out";


    public LossyLinkStaticModel()
    {
      init(1);
    }

    public static void init( int iLossModel )
    {
        dGoodLinkRate = 0.80;
        //dGoodLinkRate = 0.9;


	if( iLossModel == 1 )
	{
	    //LM1
	    dGoodLinkLossRateMin = 0.00;//LM1
	    dGoodLinkLossRateMax = 0.003;//LM1
	    dBadLinkLossRateMin = 0.05;//LM1
	    dBadLinkLossRateMax = 0.10;//LM1
	}
        else if( iLossModel == 2 )
	{
	    //LM2
	    dGoodLinkLossRateMin = 0.00;//LM2
	    dGoodLinkLossRateMax = 0.003;//LM2
	    dBadLinkLossRateMin = 0.01;//LM2
	    dBadLinkLossRateMax = 1.00;//LM2
	}
	else
	{
	    System.out.println("LLM ERROR : Incorrect Loss Model specification." );
	    System.exit(0);
	}
    }

    public static void generateLossyLink( int iLinkCount )
    {
	//Specify good link loss rates
	int iGoodLinkCount = (int)( dGoodLinkRate * iLinkCount );
	int iLinkIndex = 0;

	dLinkLossRate = new double[iLinkCount];

        for( int i = 0; i < dLinkLossRate.length; ++i )
        {
          dLinkLossRate[i] = -1.0;
        }

	for( int i = 0; i < iGoodLinkCount; ++i )
	{
	    iLinkIndex = (int)( Math.random() * iLinkCount -1 );
            LossyLinkDebug.println("iLinkIndex = (int)( Math.random() * ( iLinkCount-1 ) )\t" + iLinkIndex + " " + iLinkCount );
            while( dLinkLossRate[ iLinkIndex ] != -1.0 )
            {
                iLinkIndex = (int)( Math.random() * iLinkCount -1 );
            }
            dGoodLinkLossRate = ( Math.random() * dGoodLinkLossRateMax ) + dGoodLinkLossRateMin;
            LossyLinkDebug.println("dGoodLinkLossRate : iLinkIndex : " + iLinkIndex + " LossRate : " + dGoodLinkLossRate );
            if( dGoodLinkLossRate > 1.0 )
            {
                System.out.println( "ERROR 00100" );
		System.exit( 1 );
            }
	    dLinkLossRate[iLinkIndex] = dGoodLinkLossRate;
	}

	//Specify bad link loss rates
        int j = 0;
        for( int i = 0; i < iLinkCount; ++i )
	{
	    if( dLinkLossRate[i] == -1.0 ) //if no loss rate specified.
	    {
                dBadLinkLossRate = ( Math.random() * ( dBadLinkLossRateMax - dBadLinkLossRateMin ) ) + dBadLinkLossRateMin;
                LossyLinkDebug.println("dBadLinkLossRate : iLinkIndex : " + i + " LossRate : " + dBadLinkLossRate );
		dLinkLossRate[i] = dBadLinkLossRate;
                j++;
	    }
	}

        if( j != iLinkCount - iGoodLinkCount )
        {
            System.out.println( "ERROR 00120 : # of bad links not correct. [" + j + "], should be [" + (iLinkCount - iGoodLinkCount) + "]" );
            System.exit( 1 );
        }
    }

///??? for debug?
    public static void countLossyLink( LossyLinkData data )
    {
	int iLinkCount = data.link.count();
        int iLossyLinkCount = 0;
        int iGoodLinkCount = 0;

        for( int i = 0; i < iLinkCount; ++i )
        {
            if( data.link.getLossRate( i ) >= dBadLinkLossRateMin
               && data.link.getLossRate( i ) < dBadLinkLossRateMax )
            {
                iLossyLinkCount++;
            }
	    else
            {
		iGoodLinkCount++;
	    }
        }

        return;
    }

    public static void writeLossyLink( String strFileName )
    {
        if( strFileName == null )
        {
            Calendar calendar = Calendar.getInstance();
            strFileName = "LinkLossRate" + "_"
                                      + calendar.get( Calendar.DAY_OF_MONTH ) + "-"
                                      + calendar.get( Calendar.MONTH ) + "-"
                                      + calendar.get( Calendar.YEAR ) + "_"
                                      + calendar.get( Calendar.HOUR ) + "-"
                                      + calendar.get( Calendar.MINUTE )
                                      + ".out";

        }

        int iColCount = dLinkLossRate.length;
        try
        {
            FileWriter output = new FileWriter( strFileName );
            output.write( Integer.toString( iColCount ) );
            output.write( '\n' );
            for( int i = 0; i < iColCount; ++i )
            {
                output.write( Double.toString(dLinkLossRate[i]) );
                output.write( '\n' );
            }
            output.close();
        }
        catch (IOException e)
        {
            System.err.println( "LossyLinkPathInfo : File not written properely\n" + e.toString());
            System.exit(1);
        }

    }

    public static void main(String[] args)
    {
        init(1);
	generateLossyLink( iLinkCount );
	writeLossyLink( strLinkLossRateFile );
    }

}












