/**
 *OBJECT:	This class is used
 *				for an adjacency list representation of
 *				a graph.
 *
 * @version    $Id: Node.java,v 1.1 12/26/2001
 *
 * @author    Mark Rabin
 *
 * Revisions:
 *     $Log: Node.java,v 1.1$
 *     Revision 1.1  12/26/2001
 *     Initial revision
 *
 */


// package LossyLink;


public class Node {
	int id;
	Node next;
	double edgeWeight; //weight from head Node to this Node
        int iLinkIndex;    //index of a link from head node to this node
	/**
	* Constructor to initialize the node.
	*
	* @param id the identification number of the new node
	*/
	public Node( int id ) {
		this.id = id;
	}

	/**
	* Assigns the next node in the adjacency list
	*
	* @param next the node that will be connected to this one
	* @param edgeWeight the weight from the head node to the added node
	*/

       public void setNext ( Node next, double edgeWeight ) {
         setNext( next, edgeWeight, -1 );
       }
       public void setNext ( Node next, double edgeWeight, int iLinkIndex ) {
		this.next = next;
		this.edgeWeight = edgeWeight;
                this.iLinkIndex = iLinkIndex;
      }

}
