function [V, R] = RunBrite( inputScriptFile, isWindows )

strBriteFile   ='';
strBfile       ='';
strIfile       ='';
strMatFile     ='';    
strGfile       ='';


% Open input script file --------------------------------------------------
fid = fopen( inputScriptFile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', inputScriptFile );
end

readEndFlag = 0;
topologyTypeFlag = 0;    %0:simulated topology, 1:real topology.

while 1
    [strRead, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
    
    if readCount == 0
        break;
    end

    if strcmpi( strRead, 'Gfile' ) == 1
        [strEqual, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000021 : Unexpected end of line');
            return;
        end

        [strValue, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000022 : Can not read [%s] name from input script file [%s]', strValue, inputScriptFile );
            return;
        end

	strGfile = strValue;

        readEndFlag = readEndFlag + 1;
        topologyTypeFlag = 1;
    end

    if strcmpi( strRead, 'BriteFile' ) == 1
        [strEqual, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000021 : Unexpected end of line');
            return;
        end
        
        [strValue, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000022 : Can not read [%s] name from input script file [%s]', strValue, inputScriptFile );
            return;
        end

	strBriteFile = strValue;
        readEndFlag = readEndFlag + 1;
    end        

    if strcmpi( strRead, 'outputFileName' ) == 1
        [strEqual, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000011 : Unexpected end of line');
            return;
        end
        
        [strValue, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000012 : Can not read [%s] name from input script file [%s]', strValue, inputScriptFile );
            return;
        end

        strGfile = strcat( strValue, '_G.out' );
        strIfile = strcat( strValue, '_I.out' );
        strBfile = strcat( strValue, '_B.out' );
        strBbarFile = strcat( strValue, '_Bbar.out' );
        strMatFile = strValue;

        readEndFlag = readEndFlag + 1;
    end

    if strcmpi( strRead, 'EndHostCount' ) == 1
        [strEqual, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000031 : Unexpected end of line');
            return;
        end
        
        [strValue, readCount] = fscanf( fid, '%s[\t\n\r\f= ]' );
        if readCount == 0
            fprintf('ERROR 000032 : Can not read [%s] name from input script file [%s]', strValue, inputScriptFile );
            return;
        end        
	
	num_end_hosts = str2num( strValue );
        readEndFlag = readEndFlag + 1;
    end
end

fclose( fid );



if topologyTypeFlag == 0 & readEndFlag ~= 3
    fprintf( 'ERROR 00002 : Input script file [%s] does not contain every information needed [%d][%d]', inputScriptFile, topologyTypeFlag, readEndFlag );
    return;
end
if topologyTypeFlag == 1 & readEndFlag ~= 2
    fprintf( 'ERROR 00012 : Input script file [%s] does not contain every information needed [%d][%d]', inputScriptFile, topologyTypeFlag, readEndFlag );
    return;
end


% for MS Windows - Unix compatibility -------------------
if isWindows == 1
    strrep( strBriteFile, '/', '\\' );
    strrep( strBfile, '/', '\\' );
    strrep( strBbarFile, '/', '\\' );
    strrep( strIfile, '/', '\\' );
    strrep( strMatFile, '/', '\\' );    
    strrep( strGfile, '/', '\\' );
end

% for debug -------------------------------------------
fprintf( '%s\n%s\n%s\n%s\n%s\n%s\n', strBriteFile, strBfile, strBbarFile, strIfile, strMatFile, strGfile );


% call appropriate functions -----------------------------

if topologyTypeFlag == 0 
      fprintf('Init brite -------------------------------------------------\n');
      initbrite;
end

      fprintf('calculateG -------------------------------------------------\n');
      calculateG2;

fprintf('Runbrite terminated normally -------------------------------\n');






