//############################################################################
// SimpleInput.java
//############################################################################

// package LossyLink;

import java.io.*;

/** This is a "static" class of simple formatted I/O routines
  * that perform text input from the console.
  *
  * @author             Andrew Kitchen
  * @version            Wed Sep 13 11:59:32 EDT 2000
  */
public class SimpleInput {

   static BufferedReader input =
      new BufferedReader( new InputStreamReader( System.in ) );

   //-------------------------------------------------------------------------
   /** Read an integer (alone on a line) from standard input.
     *
     * @return		an integer
     */
   public static int readInt() throws Exception {
      return Integer.parseInt( input.readLine().trim() );
   }

   //-------------------------------------------------------------------------
   /** Read a line of text from standard input.
     *
     * @return		a string
     */
   public static String readString() throws Exception {
      return input.readLine().trim();
   }

}
