function out = Xvector( GmatrixFileName, BvectorFileName, outputFileName )

fid = fopen( GmatrixFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', GmatrixFileName );
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
G = spalloc( nrows, ncols, nnz );

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        G( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );

%
%for i = 1 : nrows
%    for j = 1 : ncols
%        if G( i, j ) == 1;
%            fprintf( 'X' );
%        else 
%            fprintf( '.' );
%        end
%    end
%    fprintf( '\n' );
%end
%disp( G );

% ----------------------------------------------------


fidBvector = fopen( BvectorFileName, 'r' );
if fidBvector == -1
    fprintf('ERROR : Can not read file %s', BvectorFileName );
end

ncols = fscanf( fidBvector, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    element = fscanf( fidBvector, '%f[\t\n\r\f ]' );
    B(i,1) = log( element );
end

fclose( fidBvector );

%disp( B );

% ----------------------------------------------------

x=  G\B;
% 
% fprintf('X vector --------------------------------\n');
% disp(x);


% ----------------------------------------------------


fidWrite = fopen( outputFileName, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', outputFileName );
end

ncols = length( x );
fprintf( fidWrite, '%d\n', ncols );     % Total link count in the topology
fprintf( fidWrite, '%d\n', ncols );     % Link count in x file (used for compatibility with newXvector.m)
for i = 1 : ncols
    fprintf( fidWrite, '%d\t%f\n', i-1, x(i) );     % <0 based index>   <value>
end

fclose( fidWrite );
