% Given b_bar, calculate x_G, then b_hat

stat_endHostCount = -1;
stat_overlayEndHostCount = -1;
stat_pathCount = -1;
load( strMatFile );

param = [];
param.precision = 'single';
param.layout    = 'packed';
param.tol       = 1e-3;

% Open b bar Vector ---------------------------------------------------
fid = fopen( strBbarFile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', strBbarFile );
end

ncols = fscanf( fid, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    element = fscanf( fid, '%f[\t\n\r\f ]' );
    
    
    if element == 0.0
      element = 0.000001;
    end
    
    
    
    bbar(i,1) = log( element );
end

fclose( fid );
% ---------------------------------------------------------------------

% Open I Vector -------------------------------------------------------
I = [];
fid = fopen( strIfile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', strIfile );
end

ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nrows = fscanf( fid, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    I(i,1) = fscanf( fid, '%f[\t\n\r\f ]' );
end

fclose( fid );
% ---------------------------------------------------------------------

[xG, stat_rank] = compute_xG(Gbar, R, bbar, param);


%R
%sort( xG )
%exp( xG )



%bbarhat = Gbar * xG;
%exp( bbarhat )




bhat = G * xG;
for i = 1 : length(I)
%     fprintf( 'bbar[%f] bhat[%f]', bbar(i), bhat(I(i)+1) );
%     if( abs( bbar(i) - bhat(I(i)+1) ) >= 0.0000001 )
%         fprintf(' *****');
%     end
%     fprintf('\n');
     bhat(I(i)+1) = bbar(i);
end



fprintf( 'size of bhat \n' );
size(bhat)





fprintf('Residual error for random bbar = %g\n', ...
        norm(Gbar*xG - bbar, 'fro'));




% output Bhat vector ----------------------------------------------------
fidWrite = fopen( strBhatFile, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', strBhatFile );
end

%fprintf( fidWrite, '%d\n', initialLinkCount );       % initial link count
fprintf( fidWrite, '%d\n', length( bhat ) );    % computabe link count
for i = 1 : length( bhat )
    fprintf( fidWrite, '%f\n', exp( bhat(i) ) );
end

fclose( fidWrite );


% output stat -----------------------------------------------------------
fidWrite = fopen( strOutputFile, 'a+' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', strOutputFile );
end


fprintf( fidWrite, 'End_host_count\t%d\n', stat_endHostCount );
fprintf( fidWrite, 'Overlay_end_host_count\t%d\n', stat_overlayEndHostCount );
fprintf( fidWrite, 'Path_count\t%d\n', stat_pathCount );
fprintf( fidWrite, 'Rank\t%d\n', stat_rank );
fclose( fidWrite );

