
param = [];
param.precision = 'single';
param.layout    = 'packed';
param.tol       = 1e-3;

if topologyTypeFlag == 0
    G     = pathmatrix(end_hosts, adj, A);
else
    G     = readG( strGfile );
    stat_endHostCount = -1;
    stat_overlayEndHostCount = -1;
    stat_pathCount = size( G, 1 );
end

%fprintf('size of G\n');
%disp( size(G) );
%I = colselect(G);

t0 = clock;
[I,R] = rowselect(G, param);
fprintf('   Monitored path selection completed in %f seconds\n', etime(clock, t0));

fprintf('size of I\n');
size_I = size(I)

Gbar  = G(I,:);

fprintf('size of Gbar\n');
size_Gbar = size(Gbar)

fprintf('rank of Gbar is %d\n', rank(full(Gbar)));


if topologyTypeFlag == 0
  %If running a synthetic topology
  
  % output G matrix --------
  stat_pathCount = saveG( G, strGfile );

  % output Index vector -----
  size_I = size( I ); 
  fprintf( 'size_I : %d %d', size_I(1), size_I(2) );
  p = 1;
  data(p) = size_I(2); p = p+1;
  data(p) = size_I(1); p = p+1;
  kcount  = size_I(1) * size_I(2);
  data(p:p+kcount-1) = I-1; p = p + kcount;

  fidWrite = fopen( strIfile, 'w' );
  if fidWrite == -1
     fprintf('ERROR : Can not write file %s\n', strIfile );
  end
  fprintf( fidWrite, '%d\n', data );
  fclose( fidWrite );
  % --------------------------

else  % --------------------------------------------------------------

  
  %I put it here for debugging purpose
  % output Index vector -----
  size_I = size( I ); 
  fprintf( 'size_I : %d %d', size_I(1), size_I(2) );
  p = 1;
  data(p) = size_I(2); p = p+1;
  data(p) = size_I(1); p = p+1;
  kcount  = size_I(1) * size_I(2);
  data(p:p+kcount-1) = I-1; p = p + kcount;

  fidWrite = fopen( strIfile, 'w' );
  if fidWrite == -1
     fprintf('ERROR : Can not write file %s\n', strIfile );
  end
  fprintf( fidWrite, '%d\n', data );
  fclose( fidWrite );
  % --------------------------

%If running a REAL topology, read b vector and save b bar using i vector.
  % Open b Vector -------------
  fid = fopen( strBfile, 'r' );
  if fid == -1
      fprintf('ERROR : Can not read file %s', strBfile );
  end

  ncols = fscanf( fid, '%d[\t\n\r\f ]' );
  for i = 1 : ncols
      element = fscanf( fid, '%f[\t\n\r\f ]' );
      b(i,1) = element;
  end
  fclose( fid );
  % ----------------------------

%  for i = 1 : length(I)
%      bbar[i] = b(I);
%  end

  bbar = b(I);

  % Output b Vector --------------
  fid = fopen( strBbarFile, 'w' );
  if fid == -1
      fprintf('ERROR : Can not write file %s', strBbarFile );
  end

  fprintf( fid, '%d\n', length( bbar ) );
  for i = 1 : length( bbar )
      fprintf( fid, '%f\n', bbar( i ) );
  end
  fclose( fid );
  % ----------------------------


end



save( strMatFile, 'G', 'Gbar', 'R', 'I', 'param', ...
                  'stat_endHostCount', ...
                  'stat_overlayEndHostCount', ...
                  'stat_pathCount' );
















