function calculateX( strGfile, strGbarFile, strBbarFile, strRfile, strXfile, strBhatFile )%, strPathIndexFile )

% Open G matrix --------------------------------------------
fid = fopen( strGfile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', strGfile );
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
G = spalloc( nrows, ncols, nnz )

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        G( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );


% eliminate the columns with 0s. Sort of pruning.
%G2 = [];
%for j = 1 : ncols
%   iZeroCount = 0;
%   for i = 1 : nrows
%      if G(i,j) ~= 0
%         break;
%      end
%      iZeroCount = iZeroCount+1;
%   end
%   if iZeroCount ~= nrows
%      [nrows_G2, ncols_G2] = size( G2 );
%      G2( :, ncols_G2+1 ) = G( :, j );
%   end
%end

fprintf('size of G');
disp( size(G) );
%fprintf('size of G2');
%disp( size(G2) );
%
%if issparse( G2 )
%     fprintf('G2 is sparse\n');
%else 
%     fprintf('G2 is not sparse\n' );
%end
%
%G = G2;

if issparse( G )
     fprintf('G is sparse\n');
else
     fprintf('G is not sparse\n');
end

% Open G bar matrix --------------------------------------------
fid = fopen( strGbarFile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', strGbarFile );
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
fprintf('Gbar\n');
Gbar = spalloc( nrows, ncols, nnz )

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        Gbar( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );

% eliminate the columns with 0s. Sort of pruning.
%Gbar2 = [];
%for j = 1 : ncols
%   iZeroCount = 0;
%   for i = 1 : nrows
%      if Gbar(i,j) ~= 0
%         break;
%      end
%      iZeroCount = iZeroCount+1;
%   end
%   if iZeroCount ~= nrows
%      [nrows_Gbar2, ncols_Gbar2] = size( Gbar2 );
%      Gbar2( :, ncols_Gbar2 + 1 ) = Gbar( :, j );
%   end
%end

fprintf('size of Gbar');
disp( size(Gbar) );
%fprintf('size of Gbar2');
%disp( size(Gbar2) );
%Gbar = Gbar2;

% Open B bar Vector ----------------------------------------------------
fid = fopen( strBbarFile, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', strBbarFile );
end

ncols = fscanf( fid, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    element = fscanf( fid, '%f[\t\n\r\f ]' );
    Bbar(i,1) = log( element );
end

fclose( fid );


% Open Path Index List File ----------------------------------------------------
%fid = fopen( pathIndexListFileName, 'r' );
%if fid == -1
%    fprintf('ERROR : Can not read file %s', pathIndexListFileName );
%end
%
%ncols = fscanf( fid, '%d[\t\n\r\f ]' );
%for i = 1 : ncols
%    element = fscanf( fid, '%d[\t\n\r\f ]' );
%    pathIndexList(i) = element;
%end
%
%fclose( fid );



% Open R Vector ----------------------------------------------------
%fid = fopen( strRfile, 'r' );
%if fid == -1
%    fprintf('ERROR : Can not read file %s', strRfile );
%end
%
%nrows = fscanf( fid, '%d[\t\n\r\f ]' );
%ncols = fscanf( fid, '%d[\t\n\r\f ]' );
%
%for i = 1 : nrows
%    for j = 1: ncols
%        R(i, j) = fscanf( fid, '%f[\t\r\f ]' );
%    end
%end
%
%fclose( fid );
% end open ---------------------------------------------------------------------




GbarTrans = Gbar';


[Q, R] = qr( GbarTrans );


fprintf( 'size of G \n' );
disp( size( G ) );
fprintf( 'size of Gbar \n' );
disp( size( Gbar ) );
fprintf( 'size of Bbar \n' );
disp( size( Bbar ) );
fprintf( 'size of R \n' );
disp( size( R ) );
fprintf( 'size of R trans \n' );
disp( size( R' ) );


if issparse( R )
     fprintf('R is sparse\n');
else
     fprintf('R is not sparse\n');
end

Xtilde = ( R' * R ) \ Bbar;




%R = double( R );
%size( R )     % for debug
%R = reshape( R, 100, floor( prod( size( R ) )/100 ) );
%size( R )     % for debug

%Xtilde = block_trs( R, Bbar, 1 );
%Xtilde = block_trs( R, Xtilde );

fprintf( 'size of Xtilde \n' );
disp(size(Xtilde));
%fprintf( 'Xtilde \n' );
%disp(Xtilde);

X = GbarTrans * Xtilde;

fprintf( 'size of X \n' );
size(X)
%fprintf( 'X \n' );
%disp(exp(X));

Bhat = G * X;
fprintf( 'size of Bhat \n' );
size(Bhat)
%disp(exp(Bhat));




fprintf('Show R, X');
%disp( R );
%disp( X );




% output R matrix ------------------------------------------
%   fidWrite = fopen( 'R.out' , 'w' );
%   if fidWrite == -1
%      fprintf('ERROR : Can not write file R.out' );
%   end
% 
%   fprintf( 'a\n' );
% 
%   size_R = size( R );
% 
%   fprintf( 'a\n' );
% 
%   % for debug
%   fprintf( '%d %d', size_R(1), size_R(2) );
% 
%   fprintf( 'a\n' );
% 
%   fprintf( fidWrite, '%d\n', size_R(1) );
%   fprintf( fidWrite, '%d\n', size_R(2) );
%   for ii = 1 : size_R(1)
%       for jj = 1 : size_R(2)
%           fprintf( fidWrite, '%f ', double( R(ii, jj) ) );
%       end
%       fprintf( fidWrite, '\n' );
%   end
%   
%   fclose( fidWrite );
  % end output -----------------------------------------------


% output X vector ----------------------------------------------------
%fidWrite = fopen( strXfile, 'w' );
%if fidWrite == -1
%    fprintf('ERROR : Can not write file %s', strXfile );
%end

%fprintf( fidWrite, '%d\n', initialLinkCount );       % initial link count
%fprintf( fidWrite, '%d\n', length( X ) );    % computabe link count
%for i = 1 : length( X )
%    fprintf( fidWrite, '%f\n', 1-exp(X(i)) );
%end

%fclose( fidWrite );

% output Bhat vector ----------------------------------------------------
fidWrite = fopen( strBhatFile, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', strBhatFile );
end

%fprintf( fidWrite, '%d\n', initialLinkCount );       % initial link count
fprintf( fidWrite, '%d\n', length( Bhat ) );    % computabe link count
for i = 1 : length( Bhat )
    fprintf( fidWrite, '%f\n', exp(Bhat(i)) );
end

fclose( fidWrite );















