package cluster;

/*************************************************************************************
* <CODE>Distance</CODE> is used for representing n-space performance distance between hosts.
*
* @author Chris Karlof
*   <A HREF="mailto:ckarlof@eecs.berkeley.edu"> (ckarlof@eecs.berkeley.edu) </A>
**************************************************************************************/

public class Distance
{

    // distance
    private double distance;

    // number of points to calculate distance, i.e. dimension
    private int comparableDimension;

    /**
    * Constructs a <CODE>Distance</CODE> representing a <CODE>distance</CODE>
    * calculated with dimension <CODE>dimension</CODE>.
    *
    * @param distance
    *   a double representing the distance
    * @param dimension
    *   the dimension used in the calculation of the distance
    **/
    public Distance(double distance, int dimension)
    {
        this.distance = distance;
        this.comparableDimension = dimension;
    }

    /**
    * Returns the distance represented by this object.
    *
    * @return
    *   the distance represented by this object
    **/
    public double getDistance()
    {
        return distance;
    }

    /**
    * Returns dimension used in calculating the distance represented by this object.
    *
    * @return
    *   the dimension used in calculating the distance represented by this object
    **/
    public int getComparableDimension()
    {
        return comparableDimension;
    }

}






