package cluster;

import java.io.*;

/*************************************************************************************
* <CODE>Host</CODE> is used for representing hosts.
*
* @author Chris Karlof
*   <A HREF="mailto:ckarlof@eecs.berkeley.edu"> (ckarlof@eecs.berkeley.edu) </A>
**************************************************************************************/

public class Host implements Serializable
{
    private String name;
	private int num;

    /**
    * Constructs a <CODE>Host</CODE> with name <CODE>name</CODE>.
    *
    * @param host
    *   an integer representing a host
    **/
    public Host(String name)
    {
        this.name = name;
    }

    public Host(String name, int num)
    {
        this.name = name;
		this.num = num;
    }

    /**
    * Returns the name of this host.
    *
    * @return
    *   the name of this host
    **/
    public String getName()
    {
        return name;
    }

    public int getNum()
    {
        return num;
    }

    /**
    * Returns the name of this host.
    *
    * @return
    *   the name of this host
    **/
    public String toString()
    {
        return name;
    }

    /**
    * Checks for equality between two hosts.
    * @param h
    *   another host
    * @return
    *   the result of the equality check
    **/
    public boolean equals(Object h)
    {
	if(!(h instanceof Host))
	    return false;
	else
	    return (name.equals(((Host) h).getName()));
    }

    public void writeObject(ObjectOutputStream out) throws IOException
    {
	out.writeObject(name);
    }

    public void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException
    {
	name = (String) in.readObject();
    }
}















