package cluster;

import java.util.*;
import java.io.*;

public class MultipleMonitorMinimalCover extends MinimalCover implements Serializable
{
    private MonitorRank[] monitorRankings;
    
    public MultipleMonitorMinimalCover(MonitorRank[] monitorRankings, Cluster[] clusters,
				       RTTMatrix rttMatrix, String method,
				       double arg, int sizeLimit)
    {
	super(clusters,rttMatrix,method,arg,sizeLimit);
	this.monitorRankings = monitorRankings;
    }

    public Host[] getMonitors(Host h, int n)
    {
	Host[] result = new Host[n];

	for(int i=1;i<=n;i++)
	    result[i-1] = monitorRankings[super.hostMap.hash(h)].getRank(i);

	return result;
    }

    public double[] getDistances(Host h, int n)
    {
	double[] result = new double[n];

	for(int i=1;i<=n;i++)
	    result[i-1] = monitorRankings[super.hostMap.hash(h)].getNDistanceToRank(i);

	return result;
    }

}
	







