package cluster;

import java.util.*;
import java.io.*;

/** 
 * Creates new <CODE>Reading</CODE> object that is used by <CODE> SlidingWindow</CODE>
 * to refer to a single reading.
 **/
    
public class Reading {
    
    private boolean isLoss;
    private double value;
    private int numberOfReadings;
    
    public Reading () {
	numberOfReadings = 0;
	value = 0;
	isLoss = false;
    }
    
    public boolean isValid() {
	return (!isLoss && numberOfReadings > 0);
    }

    public double getValue() {
	return value;
    }


    /**
     * Considers each reading and averages out the reading
     * Will consider loss as well.
     * Since there might be 2 or more readings corresponding to a single minutes
     * an average is taken
     * The final reading is a loss iff all of these readings are losses
     **/

    public void addReading(String readString) throws NumberFormatException{
	if (readString.equals("loss")) {
	    if (numberOfReadings == 0) {
		isLoss = true;
	    }
	}
	//else is not a loss 
	else {
	    
	    isLoss = false;
	    numberOfReadings++;
	    value = (((numberOfReadings-1) * value) +  Double.parseDouble(readString)) / numberOfReadings;
	}
	
    }
    public String toString() {
	String s = "isLoss = " + isLoss + " value = " + value + " numberOfReadings = " + numberOfReadings;
	return s;
    }
}
