package cluster;

import java.io.*;

public interface WNMMSConstants
{
    public static final int NUMBER_OF_READINGS = 1440;

    public static final String DEFAULT_INTRA_ESTIMATION_METHOD = "dynamicAvgRTT"; 

    public static final String SLASH = File.separator;
    public static final String MIDDLE = SLASH + "HPC" + SLASH + "data" + SLASH;

    public static final int SLIDINGWINDOWSIZE = 10;
	// unknown signal for correlaiton coefficient analysis
    public static final double UNKNOWN = 2.0;

	// cor coef threshold for clustering the paths with the same src
	public static final double CorCoefPathClusteringThre = 0.8;

    public static final int LOSS = 10000;

	// min length of total loss to make it meaningful
	public static int LOSS_LENGTH_MIN  =5;

	// what percentage of hosts should have normal performance to the monitor
    public static final double MON_ANOMALY_THRE = 0.5;

	// what percentage of hosts congested infer the last mile congestion
    public static final double LM_CONGESTION_THRE = 0.9;

	//DEFAULT :  ".."+SLASH+"data"+SLASH+"raw-data"+SLASH; 
	//OTHER VALUES : change to another string to use another set of data 
	// public static final String BASE = ".."+SLASH+"data"+SLASH+"sliding-max"+SLASH;
	public static final String BASE = ".."+SLASH+"data"+SLASH+"raw-data"+SLASH;

	// the max value should be at least 1.2 times gmean
    public static final double ANOMALY_RATIO_THRE = 1.2;
    
    // since we never do any subclustering, all these args have been fixed
    public static final String INTERNAL_CLUSTERING_METHOD = "none";
    public static final int INTERNAL_SIZE_LIMIT = 0;
    public static final double INTERNAL_CLUSTERING_ARG = 0.0;
}


