
function [link_ids] = find_null_vars(G, stol, vtol)

if nargin < 2
  stol = 1e-5;
end

if nargin < 3
  vtol = 1e-5;
end

% Find the null space (vectors V(:,Inull))
G       = full(G);
[U,S,V] = svd(G,0);
Inull   = find(diag(S) < stol);

% Identify which components are involved
Vnull    = V(:,Inull);
Vmax     = max(abs(Vnull), [], 2);
link_ids = find(Vmax > vtol);

