
function [link_ids] = find_null_vars_0_base(outputUncomputableLink, G, stol, vtol)

if nargin < 3
  stol = 1e-5;
end

if nargin < 4
  vtol = 1e-5;
end

% Find the null space (vectors V(:,Inull))
G       = full(G);
[U,S,V] = svd(G,0);
Inull   = find(diag(S) < stol);
% Identify which components are involved
Vnull    = V(:,Inull);
Vmax     = max(abs(Vnull), [], 2);
link_ids = find(Vmax > vtol) - 1;%SHH index changed to 0 based
fprintf('Uncomputable link count : %d', length( link_ids ) );



% output result ----------------------------------------------------

fidWrite = fopen( outputUncomputableLink, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', outputUncomputableLink );
end
fprintf( fidWrite, '%d\n', length( link_ids ) );
for i = 1 : length( link_ids )
    fprintf( fidWrite, '%d\n', link_ids(i) );
end
fclose( fidWrite );


