function out = newXvector( GmatrixFileName, G3matrixFileName, BvectorFileName, outputXvectorName, outputBprimeVectorName, pathIndexListFileName )


% Open G matrix --------------------------------------------------

fid = fopen( GmatrixFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', GmatrixFileName );
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
G = spalloc( nrows, ncols, nnz )

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        G( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );

% Open condensed G matrix G3 --------------------------------------------------

fid = fopen( G3matrixFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', G3matrixFileName ); 
end

nrows = fscanf( fid, '%d[\t\n\r\f ]' );
ncols = fscanf( fid, '%d[\t\n\r\f ]' );
nnz = fscanf( fid, '%d[\t\n\r\f ]' );
%G = spalloc( nrows, ncols, nnz )

for i = 1 : nrows
    nz_in_row = fscanf( fid, '%d[\t\r\f ]' );
    for j = 1: nz_in_row
        colIndex = fscanf( fid, '%d[\t\r\f ]' );
        G3( i, colIndex + 1 ) = 1;
    end
end

fclose( fid );

% Open condensed B Vector ----------------------------------------------------

fid = fopen( BvectorFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', BvectorFileName );
end

ncols = fscanf( fid, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    element = fscanf( fid, '%f[\t\n\r\f ]' );
    B(i,1) = log( element );
end

fclose( fid );

% Open Path Index List File ----------------------------------------------------

fid = fopen( pathIndexListFileName, 'r' );
if fid == -1
    fprintf('ERROR : Can not read file %s', pathIndexListFileName );
end

ncols = fscanf( fid, '%d[\t\n\r\f ]' );
for i = 1 : ncols
    element = fscanf( fid, '%d[\t\n\r\f ]' );
    pathIndexList(i) = element;
end

fclose( fid );


% ---------------------------------------------------------------------


[ G3, linkIndexList, initialLinkCount ] = rowWiseQR( G3 );


% create  newG and new B ----------------------------------------------------

newX = G3 \ B;

% B prime vector ----------------------------------------------------
% B3 = G3 * newX;   % G' * X = B'

if( outputBprimeVectorName ~= 0 )
    GetBprimeVector( outputBprimeVectorName, pathIndexList, linkIndexList, G, B, newX );
end

% output X vector ----------------------------------------------------

fidWrite = fopen( outputXvectorName, 'w' );
if fidWrite == -1
    fprintf('ERROR : Can not write file %s', outputXvectorName );
end

fprintf( fidWrite, '%d\n', initialLinkCount );
computableLinkCount = length( newX );
fprintf( fidWrite, '%d\n', computableLinkCount );
for i = 1 : computableLinkCount
    fprintf( fidWrite, '%d\t%f\n', linkIndexList(i), newX(i) );
end

fclose( fidWrite );
