% [v] = pathv(to, p, A, ne)
%
% Generate a path vector v to a specified destination.
% Inputs:
%   to - path destination
%   p  - predecessor vector from Dijkstra
%   A  - edge identifier adjacency matrix
%   ne - number of edges

function [v] = pathv(to, p, A, ne)

n = [to];
while (p(to) > 0)
  to = p(to);
  n  = [to n];
end

if nargin < 4
  ne = full( max(max(A)) );
end

v = spalloc(ne,1, length(n));
for k = 1:length(n)-1
  id = A(n(k), n(k+1));
  v(id) = 1;
end

