#include <stdio.h>
#include <stdlib.h>

int read_edge_line(char* l, int* edges)
{
    int s;
    int d;
    int ne = 0;
    char* lsave = l;

    lsave = l;
    sscanf(l+1, "%d", &s);
    for (; *l && *l != ':'; ++l);
    if (*l != ':') {
        printf("Error in file: %s\n", lsave);
        exit(-1);
    }

    for (; *l; ++l) {
        if (*l == 'R') {
            sscanf(l+1, "%d", &d);
            *edges++ = s;
            *edges++ = d;
            ++ne;
        }
    }

    return ne;
}

#define SAFETY 20

int* read_edges(char* fname, int* ne)
{
    FILE* fp        = fopen(fname, "r");
    int   max_edges = *ne;
    int   num_edges = 0;
    int*  edge_list = realloc(NULL, 2*max_edges*sizeof(int));
    char  linebuf[65536];

    while ( fgets(linebuf, sizeof(linebuf), fp) ) {

        /* Grab more space if necessary */
        if (num_edges > max_edges - SAFETY) {
            max_edges *= 2;
            edge_list  = realloc(edge_list, 2*max_edges*sizeof(int));
        } 

        /* Read edge list */
        num_edges += read_edge_line(linebuf, edge_list + 2*num_edges);

    }

    fclose(fp);
    *ne = num_edges;
    return edge_list;
}

int main()
{
    int  num_edges = 1500000;
    int* edges = read_edges("scan+lucent", &num_edges);
    int  i;
    FILE* fp;

    fp = fopen("lucentadj", "w");
    for (i = 0; i < num_edges; ++i) {
        fprintf(fp, "%d %d 1\n", edges[2*i], edges[2*i+1]);
    }
    fclose(fp);

    fp = fopen("lucentA", "w");
    for (i = 0; i < num_edges; ++i) {
        fprintf(fp, "%d %d %d\n", edges[2*i], edges[2*i+1], i+1);
    }
    fclose(fp);

    return 0;
}
