function [data, R] = run_trial(end_hosts, sizes, adj, A, ne, strVinfoFile, strEndHostsFile )

if nargin < 5
  ne = full(max(max(A)));
end

t0 = clock;

% Start with empty set and extend
V        = [];
Vinfo    = [];
R        = fzeros(10000);
%R        = fzeros(1000);%ne);
prevsize = 0;

data = [];
fprintf('n:\tk\t%%\ttime\n');
for i = 1:length(sizes)

  fprintf('end_hosts -----------------\n');
  disp( end_hosts );
  fprintf('end_hosts end -------------\n');

  [V, R, Vinfo, k, percent, tall] = ...
     scanadd(end_hosts(1:prevsize), ...
             end_hosts(prevsize+1:sizes(i)), ...
             V, R, Vinfo, adj, A, ne, 0);

%disp(Vinfo);

  % output Vinfo matrix --------------------------------------
  fidWrite = fopen( strVinfoFile, 'w' );
  if fidWrite == -1
     fprintf('ERROR : Can not write file %s\n', strVinfoFile );
  end

  size_Vinfo = size( Vinfo );
  fprintf( 'size_Vinfo : %d %d', size_Vinfo(1), size_Vinfo(2) );
  fprintf( fidWrite, '%d\n', size_Vinfo(2) );
  fprintf( fidWrite, '%d\n', size_Vinfo(1)-1 );
  for jj = 1 : size_Vinfo(2)
      for ii = 1 : size_Vinfo(1)-1
          fprintf( fidWrite, '%d ', floor( Vinfo( ii, jj )-1 ) );
      end
      fprintf( fidWrite, '\n' );
  end
  
  fclose( fidWrite );



  % output end_hosts list --------------------------------------
  fidWrite = fopen( strEndHostsFile, 'w' );
  if fidWrite == -1
     fprintf('ERROR : Can not write file %s\n', strEndHostsFile );
  end

  size_endhosts = size( end_hosts );
  fprintf( 'size_endhosts : %d %d', sizes(i), size_endhosts(1) );
  fprintf( fidWrite, '%d\n', sizes(i) );
  fprintf( fidWrite, '%d\n', size_endhosts(1) );
  for ii = 1 : sizes(i)
      for jj = 1 : size_endhosts(1)
          fprintf( fidWrite, '%d\n', end_hosts( jj, ii )-1 );
      end
  end
  
  fclose( fidWrite );



  % output V matrix ------------------------------------------ 
%  fidWrite = fopen( 'V.out', 'w' );
%  if fidWrite == -1
%     fprintf('ERROR : Can not write file V.out' );
%  end
%
%  Vt = V';
%
%  size_V = size( Vt );
%  fprintf( 'size_V : %d %d', size_V(1), size_V(2) );
%  fprintf( fidWrite, '%d\n', size_V(1) );
%  fprintf( fidWrite, '%d\n', size_V(2) );
%  for ii = 1 : size_V(1)
%      nnz_in_row = 0; 
%      for jj = 1 : size_V(2)
%          if Vt(ii, jj) == 1
%              nnz_in_row = nnz_in_row + 1;
%          end
%      end
%      fprintf( fidWrite, '%d ', nnz_in_row );
%      
%      for jj = 1 : size_V(2)
%          if Vt(ii, jj) == 1       
%              fprintf( fidWrite, '%d ', jj-1 );
%          end
%      end
%      fprintf( fidWrite, '\n' );
%  end
%  
%  fclose( fidWrite );





  % output R matrix ------------------------------------------
%   fidWrite = fopen( 'R.out' , 'w' );
%   if fidWrite == -1
%      fprintf('ERROR : Can not write file R.out' );
%   end
% 
%   fprintf( 'a\n' );
% 
%   size_R = size( R );
% 
%   fprintf( 'a\n' );
%
%   % for debug
%   fprintf( '%d %d', size_R(1), size_R(2) );
% 
%   fprintf( 'a\n' );
% 
%   fprintf( fidWrite, '%d\n', size_R(1) );
%   fprintf( fidWrite, '%d\n', size_R(2) );
%   for ii = 1 : size_R(1)
%       for jj = 1 : size_R(2)
%           fprintf( fidWrite, '%f ', double( R(ii, jj) ) );
%       end
%       fprintf( fidWrite, '\n' );
%   end
%   
%   fclose( fidWrite );
  % end output -----------------------------------------------

  fprintf('%d:\t%d\t%2.2f\t%f\n', sizes(i), k, percent, tall);
  data = [data; sizes(i), k, percent, tall];
end

fprintf('   Run completed in %f seconds\n', etime(clock, t0));




















