%***************************************************************************
%  Author: Brian Chavez
%          cowboy@uclink.berkeley.edu
%
%  Date: 6-19-03
%  
%  Description:  Optimized and saves the graph G in full matrix form.
%
%                G - The matrix that needs to be saved.
%                strGFile - The output file name.
%                
%
%  File: ~WNMMS\src\saveG.m
%
%  Dependencies:
%
%  Version Log:
%    1.0 -- Created
%    1.1 -- added stat_pathCount field.
%***************************************************************************%

function [stat_pathCount] = saveG( G, strGfile )
  fidWrite = fopen( strGfile, 'w' );
  
  if fidWrite == -1
    fprintf('ERROR : saveG cannot write file %s\n', strGfile );
    return;
  end
  
  size_G = size( G );
  fprintf( 'size_G : %d %d \n\n', size_G(1), size_G(2) );
  fprintf( fidWrite, '%d\n', size_G(1) );
  fprintf( fidWrite, '%d\n', size_G(2) );
  stat_pathCount = size_G(1);
  
  for row = 1 : size_G(1)
    fprintf('\rSaving Gfile path %d / %d', row, size_G(1));
    nz_indicies = find(G(row,:));
    nnz_in_row = length(nz_indicies);
    
    fprintf( fidWrite, '%d ', nnz_in_row );
    for run = 1 : nnz_in_row
      fprintf( fidWrite, '%d ', (nz_indicies(run)-1) );
    end
    fprintf( fidWrite, '\n' );
        
  end
  fclose( fidWrite );






