load ../data/barabasi5000

param = [];
param.precision = 'double';
%param.layout    = 'packed';
param.layout    = 'full';
param.tol       = 1e-5;

G     = pathmatrix(end_hosts(1:80), adj, A);
[I,R] = rowselect(G, param);

x     = rand(size(G,2),1);
b     = G*x;
bbar  = b(I);
Gbar  = G(I,:);
xG    = compute_xG(Gbar, R, bbar, param);

fprintf('Residual error    (reduced) = %g\n', norm(Gbar*xG - bbar, 'fro'));
fprintf('Relative residual (reduced) = %g\n', norm(Gbar*xG - bbar, 'fro') / norm(bbar));

fprintf('Residual error    (full) = %g\n', norm(G*xG - b, 'fro'));
fprintf('Relative residual (full) = %g\n', norm(G*xG - b, 'fro') / norm(b));


[G, Gbar, R, kk] = deletepath(G, Gbar, R, 5, param);

x     = rand(size(G,2),1);
b     = G*x;
bbar  = Gbar*x;
xG    = compute_xG(Gbar, R, bbar, param);

fprintf('Residual error    (reduced) = %g\n', norm(Gbar*xG - bbar, 'fro'));
fprintf('Relative residual (reduced) = %g\n', norm(Gbar*xG - bbar, 'fro') / norm(bbar));

fprintf('Residual error    (full) = %g\n', norm(G*xG - b, 'fro'));
fprintf('Relative residual (full) = %g\n', norm(G*xG - b, 'fro') / norm(b));
