/*
 * function [x] = trsolve(R, b, trans, blockR)
 *
 * Solve the system R*x = b, where R is upper triangular.
 * Trans is 'N' for Rx = b, 'T' for R^T x = b, and blockR
 * is the block size if a block packed format is used,
 * and zero otherwise.
 */

#include <mex.h>

void mextrsolvef(int nlhs, mxArray** plhs,
                 int nrhs, const mxArray** prhs);

void mextrsolved(int nlhs, mxArray** plhs,
                 int nrhs, const mxArray** prhs);

void mexFunction(int nlhs, mxArray** plhs,
                 int nrhs, const mxArray** prhs)
{
    if (mxIsDouble(prhs[0])) {

	plhs[0] = mxCreateNumericMatrix(mxGetM(prhs[1]), 1, 
					mxDOUBLE_CLASS, mxREAL);
        mextrsolved(nlhs, plhs, nrhs, prhs);

    } else {

	plhs[0] = mxCreateNumericMatrix(mxGetM(prhs[1]), 1, 
					mxSINGLE_CLASS, mxREAL);
        mextrsolvef(nlhs, plhs, nrhs, prhs);

    }
}



